\ ********************
\ box class
\ ********************

Class CBox : public CObject


public:
      
      CPoint Temp
      CRect  Box

      int len
           
      Meth: CreateBox
      Meth: Start
      Meth: End
      Meth: Draw
      Meth: Print
      Meth: GetTop
      Meth: GetLeft
      Meth: GetBottom
      Meth: GetRight
      Meth: GetTopLeft
      Meth: GetBottomRight
      Meth: GetBoxLineColor
      Meth: GetBoxLineWidth
      Meth: SetSelected
      Meth: GetSelected
      Meth: ClearSelected
      Meth: MoveBox
      Meth: Save
      Meth: Read
      Meth: SetTopLeft
      Meth: SetBottomRight
      Meth: NormalizeBox
      Meth: GetCenter
End-Class



: CBox::GetBoxLineColor
      LineColor
;

: CBox::GetBoxLineWidth
      LineWidth
;

: CBox::CreateBox                        \ *CRect --
      Box (CRect).SetLPRECT                     \ save supplied coords
      BLACK SetLineColor
      1 SetLineWidth
;

: CBox::NormalizeBox
      Box (CRect).NormalizeRect
;

: CBox::Start                 \ *CPoint --
      (CPoint).GetXY Box (CRect).SetTop Box (CRect).SetLeft
;

: CBox::End                   \ *CPoint -- 
      (CPoint).GetXY Box (CRect).SetBottom Box (CRect).SetRight
;
 
: CBox::Draw            \  DC --
      { *DC }
      LineColor Pen (CPen).SetColor
      LineWidth Pen (CPen).SetLineSize
      PS_SOLID Pen (CPen).SetStyle
      Pen (CPen).MakePen
      *DC Pen (CPen).Select          \ select it 
      *DC NULL_BRUSH GetStockObject selectObject drop     
      *DC 
      Box (CRect).TopLeft
      Box (CRect).BottomRight Swap 1+ Swap 1+
      Rectangle drop
      Pen (CPen).Delete      

;


: CBox::MoveBox                              \ DC *CPoint --
      Over Draw               \ remove box
      (CPoint).GetXY Box (CRect).OffsetRect       
      Draw
;

: CBox::SetSelected                 \  --
      TRUE ::to Selected
;

: CBox::GetSelected
      Selected
;

: CBox::ClearSelected
      FALSE ::to selected
;


: CBox::Print
      Cr ." CBox Object " 
      Cr ." DC is      " GetDC .
      Cr ." Line Color " GetBoxLineColor .
      Cr ." Line Width " GetBoxLineWidth .
      Cr ." Group ID = " GetGroupID .
      cr ." Selected Status " GetSelected .
      cr ." Copy Status " getcopy .
      Cr ." Coords are " Box (CRect).TopLeft Swap . .
      Box (CRect).BottomRight Swap . . 
;

: CBox::GetTopLeft       \ -- x y 
      Box (CRect).TopLeft
;

: CBox::GetBottomRight       \ -- x y
      Box (CRect).BottomRight
;

: CBox::SetTopLeft       \ -- x y 
      Box (CRect).SetTop
      Box (CRect).SetLeft      
;

: CBox::SetBottomRight       \ -- x y
      Box (CRect).SetBottom
      Box (CRect).SetRight
;

: CBox::GetCenter
      Box (CRect).CenterPoint
;

: CBox::Save
\      ID_BOXOBJECT                 tempcell ! tempcell CELL WriteFile 
\      LineColor                    tempcell ! tempcell CELL WriteFile 
\      LineWidth                    tempcell ! tempcell CELL WriteFile 
\      GroupID                      tempcell ! tempcell CELL WriteFile 
\      Selected                     tempcell ! tempcell CELL WriteFile
\      Box (CRect).TopLeft drop     tempcell ! tempcell CELL WriteFile 
\      Box (CRect).TopLeft nip      tempcell ! tempcell CELL WriteFile 
\      Box (CRect).BottomRight drop tempcell ! tempcell CELL WriteFile
\      Box (CRect).BottomRight nip  tempcell ! tempcell CELL WriteFile
;