\ **********************************
\ Circle class
\ **********************************

Class CCircle  : public CObject



public:
      
      CPoint Top
      CPoint Bottom
      CPoint Left
      CPoint Right
      CPoint XY
      CRect  CBoundingRect

      int DrawText
      int len
      
      Meth: CreateCircle
      Meth: SetCircleBoundingRect
      Meth: Draw
      Meth: Print
      Meth: GetStart
      Meth: GetEnd
      Meth: GetCenter

      Meth: Draw
      Meth: MoveCircle

      Meth: SetSelected
      Meth: ClearSelected
      Meth: GetSelected

      Meth: Group
      Meth: UnGroup

End-Class

: CCircle::Group        \ id
      to GroupID
;

: CCircle::UnGroup
      0 to GroupID
;

: CCircle::CreateCircle       \ *CRect --
      CBoundingRect (CRect).SetLPRECT
      CBoundingRect (CRect).TopLeft >r CBoundingRect (CRect).BottomRight drop Over - 2 / + r> Top (CPoint).SetXY
      CBoundingRect (CRect).TopLeft drop CBoundingRect (CRect).BottomRight >r Over - 2 / + r> Bottom (CPoint).SetXY
      CBoundingRect (CRect).TopLeft CBoundingRect (CRect).BottomRight Nip over - 2 / + Left (CPoint).SetXY  
      CBoundingRect (CRect).BottomRight >r CBoundingRect (CRect).TopLeft nip r> over - 2 / + Right (CPoint).SetXY  
;

: CCircle::SetCircleBoundingRect                \ *CPoint --
      (CPoint).X CBoundingRect (CRect).Right - Dup CBoundingRect (CRect).InflateRect
      CBoundingRect (CRect).TopLeft >r CBoundingRect (CRect).BottomRight drop Over - 2 / + r> Top (CPoint).SetXY
      CBoundingRect (CRect).TopLeft drop CBoundingRect (CRect).BottomRight >r Over - 2 / + r> Bottom (CPoint).SetXY
      CBoundingRect (CRect).TopLeft CBoundingRect (CRect).BottomRight Nip over - 2 / + Left (CPoint).SetXY  
      CBoundingRect (CRect).BottomRight >r CBoundingRect (CRect).TopLeft nip r> over - 2 / + Right (CPoint).SetXY       
;



: CCircle::Draw         \ DC --
            { *DC }
            PS_SOLID Pen (CPen).SetStyle
            BLACK Pen (CPen).SetColor
            Pen (CPen).MakePen
            *DC Pen (CPen).Select                      \ select it
            *DC NULL_BRUSH GetStockObject SelectObject drop
            *DC CBoundingRect (CRect).TopLeft CBoundingRect (CRect).BottomRight Ellipse drop 
            Pen (CPen).Delete
;

: CCircle::MoveCircle                              \ DC *CPoint --
       Over Draw  \ remove box
      (CPoint).GetXY CBoundingRect (CRect).OffsetRect 
     
      Draw
;


: CCircle::SetSelected
      TRUE ::to Selected
;

: CCircle::GetSelected
      Selected
;


: CCircle::ClearSelected
      FALSE ::to Selected
;

        
: CCircle::Print
      Cr ." CCircle Object  "   ." Group ID = " GetGroupID .
      Cr ." Start Coords are " CBoundingRect (CRect).TopLeft Swap ." X= " . ."  Y= " .
      Cr ." End   Coords are " CBoundingRect (CRect).BottomRight Swap ." X= " . ."  Y= " .
;


((
: CCircle::GetStart           \ -- *CPoint
      CBoundingRect (CRect).TopLeft XY (CPoint).SetXY
      XY
;
))

: CCircle::GetStart           \ -- x y
      CBoundingRect (CRect).TopLeft 
;


: CCircle::GetEnd       \ -- x y
      CBoundingRect (CRect).BottomRight
;

: CCircle::GetCenter    \ -- x,y
      CBoundingRect (CRect).CenterPoint
;
