\ **********************
\ Or Block
\ **********************

Class COrBlock : public CObject

public:

      COr     OrBox
      CBox    TextBox
      CLine   TopLine
      CLine   MiddleLine
      CLine   BottomLine
      CList   Inputs
      CPoint  temp
      CPoint  LinkOut
      CPoint  LinkIn
      CRect   BoundingRect
      CString CommentText1
      CString CommentText2
      CString CommentText3
      CString LogicText
      
      int Parent     
      int inputs

      15 Buffer: FileBuff
      
      Meth: Create
      Meth: Draw
      Meth: SetBoxText
      Meth: SetOrText 
      Meth: GetBoxText
      Meth: GetOrText 
      Meth: AddInput
      Meth: Move 
      Meth: Print
      Meth: InFindRect  
      Meth: DrawBoundingBox
      Meth: SetTextOn
      Meth: SetTextOff 
      Meth: RemoveInput
      Meth: GetInputs
      Meth: GetInput   
      Meth: GetLinkOut
      Meth: GetLinkIn                  
      Meth: SetParent
      Meth: GetParent
      Meth: Save 
      Meth: GetTop
      Meth: GetLeft
      Meth: GetBottom
      Meth: GetRight

End-Class

: COrBlock::SetBoxText       \ z$ n -- 
            case
      1 of CommentText1 (CString).SetLPCTSTR endof
      2 of CommentText2 (CString).SetLPCTSTR endof
      3 of CommentText3 (CString).SetLPCTSTR endof
      endcase  
;

: COrBlock::SetOrText       \ z$ -- 
       LogicText (CString).SetLPCTSTR
;

: COrBlock::GetBoxText       \ n -- z$
            case
      1 of CommentText1 (CString).GetLPCTSTR endof
      2 of CommentText2 (CString).GetLPCTSTR endof
      3 of CommentText3 (CString).GetLPCTSTR endof
      endcase 
;

: COrBlock::GetOrText       \  -- z$
       LogicText (CString).GetLPCTSTR
;

: COrBlock::SetTextOn               \  --
      TRUE to DrawText
;

: COrBlock::SetTextOff               \  --
      FALSE to DrawText
;



: COrBlock::Create       \ *CPoint -- 
      { *Point | id }
      NULL to Parent
      CList Dnew to Inputs
      Inputs (Clist).Erase
      10 Inputs (CList).init               \ init the inputs list for up to 10 inputs
      *Point LinkIn (CPoint).To
      \ create the top line
      *Point (CPoint).X *Point (CPoint).Y  *Point (CPoint).X *Point (CPoint).Y 10 + TopLine (CLine).CreateLine

    
      \ create the text box
      *Point (CPoint).GetXY Swap 50 - swap 10 + 100 40 BoundingRect (CRect).SetXYWH
      BoundingRect TextBox (CBox).CreateBox  
 

      \ create the middle line
      *Point (CPoint).X *Point (CPoint).Y 50 + *Point (CPoint).X *Point (CPoint).Y 60 + MiddleLine (CLine).CreateLine  
      
      \ create the OR box
      *Point (CPoint).GetXY Swap 30 - swap 60 + 60 60 BoundingRect (CRect).SetXYWH
      BoundingRect OrBox (COr).CreateOr   

      \ create the bottom line
      
      *Point (CPoint).X *Point (CPoint).Y 113 + *Point (CPoint).X *Point (CPoint).Y 130 + BottomLine (CLine).CreateLine
      *Point (CPoint).X *Point (CPoint).Y 130 +  LinkOut (CPoint).SetXY
      
      TextBox (CBox).GetTopLeft drop BoundingRect (CRect).SetLeft
      TopLine (CLine).GetStart (CPoint).Y BoundingRect (CRect).SetTop
      TextBox (CBox).GetBottomRight drop  BoundingRect (CRect).SetRight
      BottomLine (CLIne).GetEnd (CPoint).Y BoundingRect (CRect).SetBottom
      
;
 

: COrBlock::DrawBoundingBox   \ *DC --
      { *DC }
      Red to LineColor
      LineColor Pen (CPen).SetColor
      LineWidth Pen (CPen).SetLineSize
      PS_DOT
      Pen (CPen).SetStyle
      Pen (CPen).MakePen
      *DC Pen (CPen).Select          \ select it      
      *DC BoundingRect (CRect).TopLeft temp ::MoveToEx drop
      *DC BoundingRect (CRect).BottomRight drop BoundingRect (CRect).TopLeft Nip ::LineTo drop
      *DC BoundingRect (CRect).BottomRight ::LineTo drop
      *DC BoundingRect (CRect).TopLeft drop BoundingRect (CRect).BottomRight Nip ::LineTo drop
      *DC BoundingRect (CRect).TopLeft ::LineTo drop
      *DC BLUE BoundingRect (CRect).CenterPoint DrawBox  
      Pen (CPen).Delete 
;     



: COrBlock::Draw      \  DC -- 
      { *DC | Text$ }
      *DC TopLine (CLine).Draw  
      *DC TextBox (CBox).Draw  
      *DC MiddleLine (CLine).Draw     
      *DC OrBox (COr).Draw
      *DC BottomLine (CLine).Draw
      DrawText
      If
       CommentText1 (CString).IsEmpty 0=
       If
         CommentText1 (CString).GetLPCTSTR to Text$
         *DC TextBox (CBox).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 19 - Text$ zcount TextOut Drop
       Then
       
       CommentText2 (CString).IsEmpty 0=
       If
         CommentText2 (CString).GetLPCTSTR to Text$
         *DC TextBox (CBox).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 7 - Text$ zcount TextOut Drop
       Then       
       
       CommentText3 (CString).IsEmpty 0=
       If
         CommentText3 (CString).GetLPCTSTR to Text$
         *DC TextBox (CBox).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 5 + Text$ zcount TextOut Drop
       Then       
       
       
       LogicText (CString).IsEmpty 0=
       If 
         LogicText (CString).GetLPCTSTR to Text$
         *DC OrBox (COr).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 4 - Text$ zcount TextOut Drop
       Then
      Then
      Selected
      If
       *DC DrawBoundingBox
      Then
;

 
: COrBlock::Move            \ *DC *CPoint
      { *DC *Point }
      *DC *Point TopLine (CLine).move
      *DC *Point TextBox (CBox).moveBox
      *DC *Point middleLine (CLine).move
      *DC *Point OrBox (COr).moveOr
      *DC *Point BottomLine (CLine).move
      *Point (CPoint).GetXY BoundingRect (CRect).OffsetRect
      *Point LinkIn  (CPoint).+=
      *Point LinkOut (CPoint).+=
;
 

: COrBlock::Print
      Cr ." And Entity"
      Cr TopLine (CLine).Print
      cr TextBox (CBox).Print
      Cr middleline (CLine).Print
      cr Orbox (COr).Print
      Cr bottomline (CLine).Print      
;


: COrBlock::InFindRect            \ *Rect -- f
      { *Rect }
      BoundingRect (CRect).TopLeft *Rect (CRect).XYPtInRect
      BoundingRect (CRect).BottomRight *Rect (CRect).XYPtInRect And
;  

: COrBlock::AddInput          \ id -- 
      { id }
     \ first check if we have this id
     TRUE                                 \ flag assume for now we dont have this id
     Inputs (CList).Items 0
     ?Do
       i Inputs (CList).FetchItem id =    \ check
       If                                 \ ok we have it allready
        Drop FALSE Leave                  \ change flag and leave
       then
      loop
      if                                  \ not found
       id Inputs (CList).Add
      then
;

: COrBlock::GetInputs        \ -- n
      Inputs (CList).Items
;

: COrBlock::RemoveInput        \ *Item --
      { *Item | *List *Obj }
      Inputs (CList).Items 0 >
      If
      CList Dnew to *List          \ make a new list
      20 *List (CList).init        \ initalize it 
      Inputs (CList).Items 0
      ?Do
        i Inputs (CList).FetchItem to *Obj
        *Item *Obj <>
        If
         *Obj *List (CList).add    \ not this one so add to new list
        Then
       Loop
       Inputs (CList).Free          \ free old list
       Inputs delete                \ get rid of old list
       *List to Inputs              \ new list becomes current
       Then
;



: COrBlock::GetInput         \ n -- n
      Inputs (CList).FetchItem
;

: COrBlock::GetLinkIn  \ -- x y
      LinkIn (CPoint).GetXY
;

: COrBlock::GetLinkOut
      LinkOut (CPoint).GetXY
;

: COrBlock::SetParent  \ n --
      To Parent
;

: COrBlock::GetParent
      Parent
;

: COrBlock::Save
      ID_ORBLOCK            FileBuff ! FileBuff CELL WriteFile ior If z" OrBlocK Failed to write type" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      LinkIn (CPoint).X     FileBuff ! FileBuff CELL WriteFile ior If z" OrBlocK Failed to write X" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      LinkIn (CPoint).Y     FileBuff ! FileBuff CELL WriteFile ior If z" OrBlocK Failed to write Y" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      FileBuff 20 Erase
      CommentText1 (CString).IsEmpty 0=
      If
       CommentText1 (CString).GetLPCTSTR  zcount FileBuff Swap ::move
       Then
      FileBuff 20 WriteFile ior If z" OrBlocK Failed to write Text1" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      
      FileBuff 20 Erase
      CommentText2 (CString).IsEmpty 0=
      If
       CommentText2 (CString).GetLPCTSTR  zcount FileBuff Swap ::move
       Then
      FileBuff 20 WriteFile ior If z" OrBlocK Failed to write Text2" ErrorBox.Msg ErrorBox.ShowMsgBox Then      
      
      FileBuff 20 Erase
      CommentText3 (CString).IsEmpty 0=
      If
       CommentText3 (CString).GetLPCTSTR  zcount FileBuff Swap ::move
       Then
      FileBuff 20 WriteFile ior If z" OrBlocK Failed to write Text3" ErrorBox.Msg ErrorBox.ShowMsgBox Then      
      
      
      
      FileBuff 20 Erase
      LogicText   (CString).IsEmpty 0=
      If
       LogicText   (CString).GetLPCTSTR  zcount FileBuff Swap ::move
      Then
      FileBuff 20 WriteFile ior If z" OrBlocK Failed to write Text2" ErrorBox.Msg ErrorBox.ShowMsgBox Then      
      Parent                  FileBuff ! FileBuff CELL WriteFile ior If z" OrBlocK Failed to write Parent" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      Inputs (CList).Items    FileBuff ! FileBuff CELL WriteFile ior If z" OrBlocK Failed to write Items" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      Inputs (CList).Items 0
      ?do
        i Inputs (CList).FetchItem FileBuff ! FileBuff CELL WriteFile ior If z" OrBloacK Failed to Write item" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      Loop

;

: COrBlock::GetTop        \ -- top
     BoundingRect (CRect).TopLeft Nip
;

: COrBlock::GetLeft        \ -- left
     BoundingRect (CRect).TopLeft Drop
;


: COrBlock::GetBottom    \ -- bottom
     BoundingRect (CRect).BottomRight nip
;

: COrBlock::GetRight   \ -- right 
     BoundingRect (CRect).BottomRight drop
;