\ parallel port driver
((
Copyright (c) 1999

MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)2380 631441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com
))

\ ---------------------------------------------------------------------------
\ fetch and store definitions
\ ---------------------------------------------------------------------------

 code pc@			\ port# -- u8
	mov	dx, bx
	in	al, dx
	mov	bl, al
	and	ebx, 255
	next,
end-code

code pc!		 	\ u8 port# --
	mov	edx, ebx
	mov	eax, 0 [ebp]
	mov	ebx, 4 [ebp]
	add	ebp, 8
	out	dx, al
	next,
end-code

\ ---------------------------------------------------------------------------
\ Parallel port definitions
\ ---------------------------------------------------------------------------

variable pp_port	\ -- addr ; holds printer port base address
  $378 pp_port !

: ppd@          \ -- b 	; return value read from printer data port
  pp_port @ pc@
;

: ppd!          \ b -- 	; store byte to printer data port
  pp_port @ pc!
;

: pps@          \ -- b 	; return value read from printer status port
  pp_port @ 1+ pc@
;

: pps!          \ b -- 	; store byte to printer status port
  pp_port @ 1+ pc!
;

: ppc@          \ -- b 	; return value read from printer control port
  pp_port @ 2+ pc@
;

: ppc!          \ b -- 	; store byte to printer control port
  pp_port @ 2+ pc!
;

\ ---------------------------------------------------------------------------

