\ BCD to binary conversion and back

((
Copyright (c) 1999
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)2380 631441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com
))


\ ------------------------------------------------------------------------------
\ 2 by 4bit BCD to binary conversion
\ ------------------------------------------------------------------------------

: bcd2bin		\ bcd -- bin
  dup			\ ( bcd bcd )		; duplicate bcd byte
  $0F0 AND		\ ( bcd nib1 )	  	; mask off top 4 bits
  4 rshift   		\ ( bcd nib1 )		; shift right 4 to put value in 4 LSB's
  10 *
  swap 			\ ( nib1 bcd )		; swap top 2 items
  $00F AND		\ ( nib1 nib2 )		; mask off bottom 4 bits
  +			\ ( bin )		; add both values to give binary
;

\ ------------------------------------------------------------------------------
\ binary conversion to 2 by 4bit BCD
\ ------------------------------------------------------------------------------

: bin2bcd	\ bin -- bcd
  10 /mod	\ ( bin1 bin10 )	; divide by ten to give units and 10's
  4 lshift	\ ( bin1 bin10 )	; shift left 4 to put value in 4 MSB's
  or 		\ ( bcd )		; or both nibbles to produce bcd
;

\ ------------------------------------------------------------------------------