(*
 * LANGUAGE    : ANS Forth
 * PROJECT     : Forth Environments
 * DESCRIPTION : FFTW3 library binding
 * CATEGORY    : Utility
 * AUTHOR      : Hanno Schwalm; 2009-12-07 18:31:08
 * change	added wisdom support
		2010-05-13 20:40:35; due to bugs wisdom import only works now!
*)

JACKAUDIO DEFINITIONS

Extern: fftw_plan "C" fftw_plan_dft_r2c_1d ( int n, double *in, fftw_complex *out, unsigned flags );
Extern: fftw_plan "C" fftw_plan_dft_c2r_1d ( int n, fftw_complex *in, double *out, unsigned flags );
Extern: void "C" fftw_destroy_plan ( fftw_plan plan );
Extern: void "C" fftw_execute ( fftw_plan plan );
Extern: int "C" fftw_import_system_wisdom ( void );
Extern: void fftw_cleanup ( );

#00 pCONSTANT #FFTW_MEASURE
#32 pCONSTANT #FFTW_PATIENT
#64 pCONSTANT #FFTW_ESTIMATE
#FFTW_ESTIMATE pCONSTANT #FFTW_PLAN_SPEED
\ #FFTW_PATIENT CONSTANT #FFTW_PLAN_SPEED
\ #FFTW_MEASURE CONSTANT #FFTW_PLAN_SPEED
