\ 2009-12-09 18:40:41, assumes 16byte aligned data buffers
\ 2009-12-19 17:01:18, overlay support, also includes code generation for vfx
\ 2009-12-22 22:07:35, adp bug fixed
\ 2009-12-26 01:49:19, optimized code in adp due to marcels assembler fixes
INCLUDE fjack/overlay.frt

[DEFINED] save-sse2-overlay?
[IF]

CODE (calc-fir-val-sse2)
HERE TO START-OVERLAYCODE
 				eax	pop,
 				ecx	pop,	\ data
 				edx	pop,	\ multipliers

 	xmm0		->	xmm0	xorpd,
BEGIN,	#16 b#		->	eax	sub,
0>=, WHILE,
	[ecx]		->	xmm1	movapd,
	[edx]		->	xmm1	mulpd,
	[ecx $10 +]	->	xmm2	movapd,
	[edx $10 +]	->	xmm2	mulpd,
	[ecx $20 +]	->	xmm3	movapd,
	[edx $20 +]	->	xmm3	mulpd,
	[ecx $30 +]	->	xmm4	movapd,
	[edx $30 +]	->	xmm4	mulpd,
	[ecx $40 +]	->	xmm5	movapd,
	[edx $40 +]	->	xmm5	mulpd,
	[ecx $50 +]	->	xmm6	movapd,
	[edx $50 +]	->	xmm6	mulpd,
	[ecx $60 +]	->	xmm7	movapd,
	[edx $60 +]	->	xmm7	mulpd,
	xmm1		->	xmm0	addpd,
	[ecx $70 +]	->	xmm1	movapd,
	[edx $70 +]	->	xmm1	mulpd,
	xmm2		->	xmm0	addpd,
	xmm3		->	xmm0	addpd,
	xmm4		->	xmm0	addpd,
	xmm5		->	xmm0	addpd,
	xmm6		->	xmm0	addpd,
	xmm7		->	xmm0	addpd,
	xmm1		->	xmm0	addpd,
	[ecx $80 +]	->	ecx	lea,
	[edx $80 +]	->	edx	lea,
REPEAT,	#16 b#		->	eax	add,
 	3 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movapd,
	[edx]		->	xmm1	mulpd,
	[ecx $10 +]	->	xmm2	movapd,
	[edx $10 +]	->	xmm2	mulpd,
	[ecx $20 +]	->	xmm3	movapd,
	[edx $20 +]	->	xmm3	mulpd,
	[ecx $30 +]	->	xmm4	movapd,
	[edx $30 +]	->	xmm4	mulpd,
	xmm1		->	xmm2	addpd,
	xmm3		->	xmm4	addpd,
	xmm2		->	xmm0	addpd,
	xmm4		->	xmm0	addpd,
	[ecx $40 +]	->	ecx	lea,
	[edx $40 +]	->	edx	lea,
THEN, 	2 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movapd,
	[edx]		->	xmm1	mulpd,
	[ecx $10 +]	->	xmm2	movapd,
	[edx $10 +]	->	xmm2	mulpd,
	xmm1		->	xmm0	addpd,
	xmm2		->	xmm0	addpd,
	[ecx $20 +]	->	ecx	lea,
	[edx $20 +]	->	edx	lea,
THEN, 	1 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movapd,
	[edx]		->	xmm1	mulpd,
	xmm1		->	xmm0	addpd,
	[ecx $10 +]	->	ecx	lea,
	[edx $10 +]	->	edx	lea,
THEN, 	0 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movsd,
	[edx]		->	xmm1	mulsd,
	xmm1		->	xmm0	addsd,
THEN,	xmm0		->	xmm1	movapd,
	1 :: xmm1	->	xmm1	shufpd,
	xmm1		->	xmm0	addsd,


	[ebp #-16 +]	->	ebp	lea,
	xmm0		->	[ebp] movsd,
	[ebp]			qword fld,
				fpush,
	[ebp #16 +]	->	ebp	lea,
				ebx jmp,
	HERE TO END-OVERLAYCODE	END-CODE	S" firval" SAVE-OVERLAY

CODE (calc-adp-muls-sse2)
HERE TO START-OVERLAYCODE
					fpop,
	[ebp -8 +]		qword	fstp,
	[ebp -8 +]	->	xmm0	movsd,
 	xmm1		->	xmm1	subpd,
	1 :: xmm0	->	xmm1	shufpd,
	xmm1		->	xmm0	addpd,
				eax	pop,	\ cnt
				ecx	pop,	\ data
				edx	pop,	\ multipliers
BEGIN,	#8 b#		->	eax	sub,
0>=, WHILE,
 	[ecx]		->	xmm1	movapd,
 	[ecx $10 +]	->	xmm2	movapd,
 	[ecx $20 +]	->	xmm3	movapd,
 	[ecx $30 +]	->	xmm4	movapd,
 	xmm0		->	xmm1	mulpd,
 	xmm0		->	xmm2	mulpd,
 	xmm0		->	xmm3	mulpd,
 	xmm0		->	xmm4	mulpd,
 	[edx]		->	xmm1	addpd,
 	[edx $10 +]	->	xmm2	addpd,
 	[edx $20 +]	->	xmm3	addpd,
 	[edx $30 +]	->	xmm4	addpd,
	xmm1		->	[edx]	movapd,
	xmm2		->	[edx $10 +] movapd,
	xmm3		->	[edx $20 +] movapd,
	xmm4		->	[edx $30 +] movapd,
 	[ecx $40 +]	->	ecx	lea,
 	[edx $40 +]	->	edx	lea,
REPEAT,	#8 b#		->	eax	add,
	2 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movapd,
 	[ecx $10 +]	->	xmm2	movapd,
 	xmm0		->	xmm1	mulpd,
 	xmm0		->	xmm2	mulpd,
 	[edx]		->	xmm1	addpd,
 	[edx $10 +]	->	xmm2	addpd,
	xmm1		->	[edx]	movapd,
	xmm2		->	[edx $10 +] movapd,
 	[ecx $20 +]	->	ecx	lea,
 	[edx $20 +]	->	edx	lea,
THEN,	1 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movapd,
 	xmm0		->	xmm1	mulpd,
 	[edx]		->	xmm1	addpd,
	xmm1		->	[edx]	movapd,
THEN,				ebx	jmp,
	HERE TO END-OVERLAYCODE END-CODE	S" adpmul" SAVE-OVERLAY

CODE (SSE2-CODE?)	( -- flag )
	-1 ALLOT HERE TO START-OVERLAYCODE
 	1 b#	->	eax	mov,
 				cpuid,
 			ebx	pop,
 	$04000000 d# ->	edx	and,
 			edx	push,
 			ebx	jmp,
	HERE TO END-OVERLAYCODE	END-CODE	S" testcpu" SAVE-OVERLAY

\ ************************************************************************************************************************
MARKER vfxcode
CODE (vfx-calc-fir-val-sse2)
-1 ALLOT HERE TO START-OVERLAYCODE
	[ebp]		->	eax	mov,	\ cnt
	[ebp 4 +]	->	ecx	mov,	\ data
	[ebp 8 +]	->	edx	mov,	\ mul
 	xmm0		->	xmm0	xorpd,
BEGIN,	#16 b#		->	eax	sub,
0>=, WHILE,
	[ecx]		->	xmm1	movapd,
	[edx]		->	xmm1	mulpd,
	[ecx $10 +]	->	xmm2	movapd,
	[edx $10 +]	->	xmm2	mulpd,
	[ecx $20 +]	->	xmm3	movapd,
	[edx $20 +]	->	xmm3	mulpd,
	[ecx $30 +]	->	xmm4	movapd,
	[edx $30 +]	->	xmm4	mulpd,
	[ecx $40 +]	->	xmm5	movapd,
	[edx $40 +]	->	xmm5	mulpd,
	[ecx $50 +]	->	xmm6	movapd,
	[edx $50 +]	->	xmm6	mulpd,
	[ecx $60 +]	->	xmm7	movapd,
	[edx $60 +]	->	xmm7	mulpd,
	xmm1		->	xmm0	addpd,
	[ecx $70 +]	->	xmm1	movapd,
	[edx $70 +]	->	xmm1	mulpd,
	xmm2		->	xmm0	addpd,
	xmm3		->	xmm0	addpd,
	xmm4		->	xmm0	addpd,
	xmm5		->	xmm0	addpd,
	xmm6		->	xmm0	addpd,
	xmm7		->	xmm0	addpd,
	xmm1		->	xmm0	addpd,
	[ecx $80 +]	->	ecx	lea,
	[edx $80 +]	->	edx	lea,
REPEAT,	#16 b#		->	eax	add,
 	3 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movapd,
	[edx]		->	xmm1	mulpd,
	[ecx $10 +]	->	xmm2	movapd,
	[edx $10 +]	->	xmm2	mulpd,
	[ecx $20 +]	->	xmm3	movapd,
	[edx $20 +]	->	xmm3	mulpd,
	[ecx $30 +]	->	xmm4	movapd,
	[edx $30 +]	->	xmm4	mulpd,
	xmm1		->	xmm2	addpd,
	xmm3		->	xmm4	addpd,
	xmm2		->	xmm0	addpd,
	xmm4		->	xmm0	addpd,
	[ecx $40 +]	->	ecx	lea,
	[edx $40 +]	->	edx	lea,
THEN, 	2 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movapd,
	[edx]		->	xmm1	mulpd,
	[ecx $10 +]	->	xmm2	movapd,
	[edx $10 +]	->	xmm2	mulpd,
	xmm1		->	xmm0	addpd,
	xmm2		->	xmm0	addpd,
	[ecx $20 +]	->	ecx	lea,
	[edx $20 +]	->	edx	lea,
THEN, 	1 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movapd,
	[edx]		->	xmm1	mulpd,
	xmm1		->	xmm0	addpd,
	[ecx $10 +]	->	ecx	lea,
	[edx $10 +]	->	edx	lea,
THEN, 	0 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movsd,
	[edx]		->	xmm1	mulsd,
	xmm1		->	xmm0	addsd,
THEN,	xmm0		->	xmm1	movapd,
	1 :: xmm1	->	xmm1	shufpd,
	xmm1		->	xmm0	addsd,
	xmm0		->	[ebx]	movsd,
	[ebp #12 +]	->	ebp	lea,
					ret,
	HERE TO END-OVERLAYCODE	END-CODE	S" v_firval" SAVE-OVERLAY

CODE (vfx-calc-adp-muls-sse2)
-1 ALLOT HERE TO START-OVERLAYCODE
	[ebp]		->	eax	mov,	\ cnt
	[ebp 4 +]	->	ecx	mov,	\ data
	[ebp 8 +]	->	edx	mov,	\ mul
	[ebx]		->	xmm0	movsd,
 	xmm1		->	xmm1	subpd,
	1 :: xmm0	->	xmm1	shufpd,
	xmm1		->	xmm0	addpd,
	[ebp #12 +]	->	ebx	mov,	\ get the new TOS
	[ebp #16 +]	->	ebp	lea,
BEGIN,	#8 b#		->	eax	sub,
0>=, WHILE,
 	[ecx]		->	xmm1	movapd,
 	[ecx $10 +]	->	xmm2	movapd,
 	[ecx $20 +]	->	xmm3	movapd,
 	[ecx $30 +]	->	xmm4	movapd,
 	xmm0		->	xmm1	mulpd,
 	xmm0		->	xmm2	mulpd,
 	xmm0		->	xmm3	mulpd,
 	xmm0		->	xmm4	mulpd,
 	[edx]		->	xmm1	addpd,
 	[edx $10 +]	->	xmm2	addpd,
 	[edx $20 +]	->	xmm3	addpd,
 	[edx $30 +]	->	xmm4	addpd,
	xmm1		->	[edx]	movapd,
	xmm2		->	[edx $10 +] movapd,
	xmm3		->	[edx $20 +] movapd,
	xmm4		->	[edx $30 +] movapd,
 	[ecx $40 +]	->	ecx	lea,
 	[edx $40 +]	->	edx	lea,
REPEAT,	#8 b#		->	eax	add,
	2 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movapd,
 	[ecx $10 +]	->	xmm2	movapd,
 	xmm0		->	xmm1	mulpd,
 	xmm0		->	xmm2	mulpd,
 	[edx]		->	xmm1	addpd,
 	[edx $10 +]	->	xmm2	addpd,
	xmm1		->	[edx]	movapd,
	xmm2		->	[edx $10 +] movapd,
 	[ecx $20 +]	->	ecx	lea,
 	[edx $20 +]	->	edx	lea,
THEN,	1 b#		->	eax	bt,
cy, IF,	[ecx]		->	xmm1	movapd,
 	xmm0		->	xmm1	mulpd,
 	[edx]		->	xmm1	addpd,
	xmm1		->	[edx]	movapd,
THEN,					ret,
	HERE TO END-OVERLAYCODE END-CODE	S" v_adpmul" SAVE-OVERLAY

CODE (vfx-SSE2-CODE?)
	-1 ALLOT HERE TO START-OVERLAYCODE
	[ebp -4 +]	->	ebp	lea,
	ebx		->	[ebp]	mov,
 	1 b#	->	eax		mov,
					cpuid,
	edx	->	ebx		mov,
	$04000000 d# ->	ebx		and,
					ret,
	HERE TO END-OVERLAYCODE	END-CODE	S" v_testcpu" SAVE-OVERLAY
vfxcode
\ ************************************************************************************************************************
[ELSE]

CODE (calc-fir-val-sse2)
	S" firval" LOAD-OVERLAY	END-CODE
CODE (calc-adp-muls-sse2)
	S" adpmul" LOAD-OVERLAY END-CODE
CODE (SSE2-CODE?)		( -- flag )
	-1 ALLOT S" testcpu" LOAD-OVERLAY END-CODE

[THEN]
