\ TSEPOS 1 1 1 \

\ The Theory that Jack Built, by Frederick Winsor

((
from The Space Child's Mother Goose
Forth Dimensions II/1 page 9

An example of factorisation that shows how much can be saved
by factoring repeated items. An enchanting piece of trivia.

to view the poem, include this file.
the computer's recitation occurs stanza by
stanza, with the operator indicating his
interest and approval by pushing any key after
each stanza ...
))

: poem  ;

: the           ." the "  ;
: that          CR ." that " ;
: this          cls  CR ." This is " THE ;
: jack          ." Jack built" ;
: summary       ." summary" ;
: flaw          ." flaw" ;
: mummery       ." mummery" ;
: k             ." constant K" ;
: haze          ." erudite verbal haze" ;
: phrase        ." turn of a plausible phrase" ;
: bluff         ." chaotic confusion and bluff" ;
: stuff         ." cybernetics and stuff" ;
: theory        ." theory " JACK ;
: button        ." button to start the machine" ;
: child         ." space child with brow serene" ;
: cybernetics   ." cybernetics and stuff" ;
: hiding        CR ." hiding " THE FLAW ;
: lay           THAT ." lay in " THE THEORY ;
: based         CR ." based on " THE MUMMERY ;
: saved         THAT ." saved " THE SUMMARY ;
: cloak         CR ." cloaking " K ;
: thick         IF    THAT
                ELSE  CR ." and "
                ENDIF
                ." thickened " THE HAZE ;
: hung           THAT ." hung on " THE PHRASE ;
: cover         IF    THAT ." covered "
                ELSE  CR ." to cover "
                THEN
                BLUFF  ;
: make          CR ." to make with " THE CYBERNETICS ;
: pushed        CR ." who pushed " BUTTON ;
: rest          46 EMIT 10 SPACES KEY DROP CR CR CR ;
: without       CR ." without confusion, exposing the bluff" ;

cr cr cr this theory rest
this flaw lay rest
this mummery hiding lay rest
this summary based hiding lay rest
this k saved based hiding lay rest
this haze cloak saved based hiding lay rest
this phrase 1 thick cloak saved based hiding lay rest
this bluff hung 1 thick cloak saved based hiding lay rest
this stuff 1 cover hung 0 thick cloak saved based hiding
     lay rest
this button make 0 cover hung 0 thick cloak saved
     based hiding lay rest
this child pushed cr ." that made with " cybernetics without
hung cr ." and, shredding " the haze cloak cr ." wrecked " the
summary based hiding cr ." and demolished " the theory rest

