\ HARNESS.FTH - Cross compiler compatibility

((
Copyright (c) 2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441

PLEASE NOTE THAT OUR PHONE NUMBER CHANGED IN APRIL 2000

To do
=====

Change history
==============
))

only forth  also h-c definitions


\ ********************
\ Memory compatibility
\ ********************

synonym cell(t)         cell
synonym c,c(t)          c,
synonym w,c(t)          w,
synonym l,c(t)          ,
synonym c@c(t)          c@
synonym w@c(t)          w@
synonym l@c(t)          @
synonym c!c(t)          c!
synonym w!c(t)          w!
synonym l!c(t)          !
synonym @c(t)           @
synonym !c(t)           !
synonym chere(t)        here
synonym callot(t)       allot
compiler
: cell(t)	cell  ;
: c@c(t)	c@  ;
: w@c(t)        w@  ;
: l@c(t)        @  ;
: c!c(t)        c!  ;
: w!c(t)        w!  ;
: l!c(t)        !  ;
: @c(t)         @  ;
: !c(t)         !  ;
: chere(t)	here  ;
: callot(t)     allot  ;
target


\ **************************
\ Search order compatibility
\ **************************

: [+assembler]  \ -- ; gives access to the assembler
  also asm-core
; immediate

: [previous]    \ -- ; restore search order
  previous
; immediate


\ **************************
\ Architecture compatibility
\ **************************

true equ single-section?

