(* ====================================================================
Show alert panel

copyright 2009 Roelf Toxopeus

VFX version.
Show alert window (Lion doesn't really like this), deprecated...
Now, it's a demonstration of error messages issued by the ObjC runtime
in the I/O window.

OSX 10.11 El Capitan
Notice the delayed backtrace dump in the Forth repl.

Last: 10 August 2020 at 07:24:17 CEST   -rt
==================================================================== *)

(( ====================================================================
HEADS MSG OKIDOKI -- tekst for panel head, the message and the ok button.
(do.alert) -- will crash and terminate VFX. See the error message in console.
There is an autoreleasepool block installed which should release the objects.
DO.ALERT -- run (do.alert) on main thread.
==================================================================== ))

/forth
decimal

function: NSRunAlertPanel ( NSStringRef:head NSStringRef:msg NSStringRef:ok n1 n2 -- ret )

: HEADS ( -- NSStringRef )    @" Cocoa Alert Panel"  ;
: MSG ( -- NSStringRef )      @" Hoi! Groeten uit Utreg"  ;
: OKIDOKI ( -- NSStringRef )  @" Back to Forth"  ;

: (do.alert) ( -- )
   allocpool
   heads msg okidoki 0 0 NSRunAlertPanel drop
   releasepool drop ;

: DO.ALERT ( -- )   0 dup ['] (do.alert) pass ;

cr .( alert demo loaded ...)
cr .( do.alert   --   starts demo)

\\ ( eof )