(* ====================================================================
Quartz draw test

copyright 2006 Roelf Toxopeus

VFX version.
Last: 4 Sep 2015 21:02:25 CEST   -rt
==================================================================== *)

(( --------------------------------------------------------------------
Testing quartz drawing.
First   DRAWWIN /GWINDOW    when included from LOAD-FILE menu.
Randomly draw lines  LL or dots DD in DRAWWIN. Any key stops.
-------------------------------------------------------------------- ))

/forth
decimal

new.window DRAWWIN
s" drawwin Choose"      drawwin w.title

: /DRAWWIN ( -- )   drawwin dup add.window /gwindow ;

/drawwin
   
: LL ( -- )
   drawwin cgcontext >r
   1e0 r@ line.width
   begin
      drawwin content.size f>s f>s 2dup
      choose s>f choose s>f choose s>f choose s>f r@ line
      16 ms ( pause)
   ?pause until
   r> drop ;

: DD ( -- )
   drawwin cgcontext >r
   begin
      drawwin content.size f>s f>s choose s>f choose s>f r@ dot
      pause
   ?pause until
   r> drop ;

cr .( CGContext demo loaded:  LL or DD )

\\ ( eof )