(* ====================================================================
Often used string words

copyright 2002 Roelf Toxopeus

VFX version.
Like in Mach2, CarbonMacForth and SwiftForth
Also published by Wil Baden.
Last: 13 October 2014 17:27:06 CEST  rt
==================================================================== *)

/forth
decimal

(( --------------------------------------------------------------------
STRING, -- puts a counted, zero terminated string in the dictionary
Z, --  compile zero terminated string 
Neither PAD or POCKET used
Note: 1+ to skip the zerobyte when jumping over a string.
-------------------------------------------------------------------- ))

\ PLACE, APPEND, ZAPPEND, ZPLACE and ZCOUNT exist in VFX

: STRING,      \ caddr len --
\ *G Lay the string into the dictionary at *\fo{HERE} as a
\ ** counted and zero terminated string. *\fo{ALIGN} the
\ ** dictionary.
  dup >r
  here place
  r> 1 chars + allot
  0 c,  align
;

: Z, ( a n -- )   z$, ;

cr .( my strings loaded)

\\ ( eof )