\ OBSOLETE.FTH - obsolete words removed from the VFX Forth kernel

((
Copyright (c) 2002-2004, 2005
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
))

\ ===========
\ *! obsolete
\ *T Obsolete words
\ ===========
\ *P The following words are now obsolete and have been removed
\ ** from the VFX kernel. If their use is required, they may be
\ ** found in *\i{LIB\OBSOLETE.FTH}.

: ALIGN&ERASE   \ --                                             MPE.0000
\ *G Align the dictionary pointer, zeroing any intermediate memory.
\ ** This word is now obsolete as *\fo{ALIGN} now performs the same action.
  align
;

: HALF-ALIGN&ERASE	\ --
\ *G *\fo{HALF-ALIGN} the dictionary pointer, zeroing any intermediate memory.
\ ** This word is now obsolete as *\fo{HALF-ALIGN} now performs the same action.
  half-align
;

: M/MOD         \ d1 n2 -- rem quot                              MPE.0000
\ *G Signed version of *\fo{UM/MOD}. This word is obsolescent and
\ ** should be replaced by *\fo{FM/MOD} (floored division) or
\ ** *\fo{SM/REM} (symmetric division).
  sm/rem
;

: CONVERT       \ ud1 c-addr1 u1 -- ud2 c-addr2                 6.2.0970
\ *G An obsolescent word corresponding to *\fo{>NUMBER DROP}.
  1+ 255 >number drop
;

cell +USER SPAN	\ -- addr
\ *G Required by *\fo{EXPECT} and Forth 83 systems.

: EXPECT        \ c-addr +n --                                   6.2.1390
\ *G Wait for input from the console. Data is stored in the buffer at
\ ** *\i{c-addr} for upto *\i{n} characters. After input is complete due to
\ ** either a full buffer or a carriage return, the length of the input
\ ** string is also stored in the variable *\fo{SPAN}. This word is marked as
\ ** obsolescent in the ANS specification, and new code should use
\ ** *\fo{ACCEPT} instead.
  accept span !
;

: v-find        \ caddr voc-xt -- cfa/cfa/caddr +1/-1/0       SYS.0000
\ *G A near equivalent to *\fo{SEARCH-WORDLIST} retained in VFX Forth as
\ ** a concession to PFW 2.x users.
  >body @ >r count r> search-wordlist
  dup 0= if  0  then
;

: all           \ -- -1 -1
\ *G A ProForth 2.x compatibility word.
  -1 -1
;

: from-file     \ start end "<name>" --
\ *G A ProForth 2.x compatibility word.
  2drop include
;

: pto           \ --                                             MPE.0000
\ *G Skip parsing until an ASCII 12 pagethrow is encountered.
  begin
    source >in @ /string
    bounds ?do
      1 >in +!
      i c@ FFEED =
      if  unloop  exit  then
    loop
    refill 0=
  until
; immediate

: winapphandle@ \ -- hwnd
\ *G Return the console parent frame window handle.
  hWndMain
;

: OFFSET        \ x "<spaces>name" -- ; Exec: n -- n+x*4        MPE.0000
( *G Create a new offset called *\i{name}. On execution of *\i{name} the      )
( ** supplied address will be incremented by *\i{x} cells.                 )
  create
    ,
  does>
    @ cells +
;

: BOFFSET       \ x "<spaces>name" -- ; Exec: n -- n+x          MPE.0000
( *G As with *\fo{OFFSET} except the increment is specified in bytes rather   )
( ** than cells.                                                        )
  create
    ,
  does>
    @ +
;

: instance      \ n -- ; -- addr                                 MPE.0000
( *G Create a named instance of a named structure.                      )
( ** A memory buffer *\i{n} bytes long called *\i{name} is built.      	)
( ** When *\i{name} is executed the address of the buffer is returned.     )
\ ** Use *\fo{buffer:} instead.
  buffer:
;


\ ******************************
\ *S Removed from VFX Forth v4.0
\ ******************************

: <<n           \ x1 u -- x2                                    MPE.0000
\ *G Logically shift *\i{X1} by *\i{U} bits left.
\ ** Use *\fo{lshift} instead.
  lshift
;

: >>n           \ x1 u -- x2                                    MPE.0000
\ *G Logically shift *\i{X1} by *\i{U} bits right.
\ ** The result of shifting by more than 31 bits is undefined.
\ ** Use *\fo{rshift} instead.
  rshift
;

: s>>n          \ x1 u -- x2                                    MPE.0000
\ *G Shift *\i{x1} right by *\i{u} bits, filling with the previous top
\ ** bit. An arithmetic right shift.
\ ** The result of shifting by more than 31 bits is undefined.
\ ** Use *\fo{arshift} instead.
  arshift
;

: ($+)          \ c-addr u $dest --			         MPE.0000
\ *G Add the string described by *\i{C-ADDR/U} to the counted string at
\ ** *\i{$DEST}. The strings must not overlap.
\ ** Use *\fo{APPEND} instead.
  >r
  tuck  r@ count +  swap cmove          \ add source to end
  r> c+!                                \ add length to count
;

: z>here        \ --
\ *G Lay the counted string at *\fo{PAD} into the dictionary at
\ ** *\fo{HERE}.
  pad count z$,
;

\ ======
\ *> ###
\ ======

