\ TSEPOS 27 2 26 \

0 value assertions?

: +assert	\ -- ; assertions will be compiled
  true to assertions?
;

: -assert	\ -- ; assertions will not be compiled
  false to assertions?
;

: check_assert	\ flag --
  r> dup @              	\ -- flag ret line#
  swap cell+            	\ -- flag line# z$
  dup zcount 1+ + >r
  rot if
    2drop
  else
    cr ." ASSERT(...) failed on line " swap . ." of file " .z$
    abort
  then
;

: ASSERT(	\ -- ; compilation only
  ?comp					\ must be compiling
  begin					\ compile code for assertion
    bl word
    dup count S" )" compare
  while
    assertions? if			\ compile or discard
      count evaluate
    else
      drop
    then
  repeat
  drop
  assertions? if			\ if assertions enabled
    ['] check_assert compile,		\ compile run time action
    line# @ ,				\ followed by line#
    CurrSourceName z$,			\ and source name
  then
; immediate

