\ WINTYPE.FTH - Windows types

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
))


\ *> ciao
( *N Windows Types                                                      )
( **                                                                    )
( *P Defines some simple classes for Windows data-types. Most simple    )
( ** types under Windows are just 32 bit numbers. Therefore the         )
( ** following types are all simply private scope derived from the      )
( ** INT type documented before.                                        )
( **                                                                    )
( *E LPVOID             HANDLE          HWND            HMENU           )
( ** HINSTANCE          LPCTSTR         LONG            DWORD           )

\ 32 bit data types

\ simple
class LPVOID    : private int end-class
class HANDLE    : private int end-class

\ handles
class HWND      : private HANDLE end-class
class HMENU     : private HANDLE end-class
class HINSTANCE : private HANDLE end-class

\ pointers
class LPCTSTR   : private LPVOID end-class

\ other
class LONG      : private int end-class
class DWORD     : private LONG end-class

( *> ### )

