\ this file requires class string

create h1$ 60 allot \ <arrayclassname>
create h2$ 60 allot \ <objectclassname>
string s$

\ declare a 1-dimensional object array of the given name with objects of the given class
: 1objArray  ( <arrayclassname> <objectclassname> -- )
 bl word ( str255 ) h1$ move$
 bl word ( str255 ) h2$ move$
 new: s$
 s" :class " put: s$
 h1$ count add: s$
 s"  <super " add: s$
 h2$ count add: s$
 s"  ' " add: s$
 h2$ count add: s$
 s"  >body (objlen) <indexed " add: s$  all: s$ evaluate
 s"  var current " put: s$  all: s$ evaluate
 s"  :m select: ?idx self get: current ^elem width move dup put: current ^elem self width move ;m " put: s$  all: s$ evaluate
 s"  :m printall: get: current limit 0 ?DO cr i select: self print: super LOOP select: self ;m " put: s$  all: s$ evaluate
 s"  :m classinit: limit 0 ?DO i select: self classinit: super LOOP 0 select: self ;m " put: s$  all: s$ evaluate
 s"  :m releaseall: limit 0 ?DO cr i release: self release: super LOOP ;m " put: s$  all: s$ evaluate
 s"  ;class" put: s$  all: s$ evaluate 
 release: s$
 ;

0 [IF]
\ example usage

:class rect
 var x1
 var y1
 var x2
 var y2


:m put: ( x1 y1 x2 y2 -- )
 put: y2 put: x2 put: y1 put: x1 ;m

:m get: ( -- x1 y1 x2 y2 )
 get: x1 get: y1 get: x2 get: y2 ;m

:m print:
 get: x1 . get: y1 . get: x2 . get: y2 . ;m

:m classinit:
 10 10 50 50 put: self ;m

;class



\ create an objectArray class named rectArray for rect objects
1objArray rectArray rect




0 [IF]
Results in compiling the following:

:class rectArray <super rect ' rect >body (objlen) <indexed
 var current


:m select: ( idx -- ^obj )
 ?idx self get: current ^elem width move dup put: current
 ^elem self width move ;m

:m printAll: limit 0 ?DO cr i select: self print: super LOOP ;m

:m classinit: 
 limit 0 ?DO i select: self classinit: super LOOP
 0 select: self ;m

:m releaseAll: limit 0 ?DO cr i release: self release: super LOOP ;m

;class

[THEN]




\ instantiate a rectArray object of 5 rects, named r5

5 rectArray r5


printall: r5

10 10 50 50 
10 10 50 50 
10 10 50 50 
10 10 50 50 
10 10 50 50 


3 select: r5

1000 2000 3000 4000 put: r5 printall: r5

10 10 50 50 
10 10 50 50 
10 10 50 50 
1000 2000 3000 4000 
10 10 50 50 


2 select: r5 print: |
10 10 50 50 

1objArray $Array string



:class test10
 5 rectArray myArray

:m print: printall: myArray ;m
;class



test10 t10



print: t10

10 10 50 50 
10 10 50 50 
10 10 50 50 
10 10 50 50 
10 10 50 50 


[THEN]
