\ SELECT.FTH - the CCS extended CASE selector

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441

PLEASE NOTE THAT OUR PHONE NUMBER CHANGED IN APRIL 2000

To do
=====

Change history
==============
))


\
\ CCS Extended CASE Selector
\ 00/05/24 16:48:01 SJC
\

VOCABULARY CCSCASE

ALSO CCSCASE DEFINITIONS

0 VALUE #EXITS
0 VALUE #LEVEL

PREVIOUS DEFINITIONS ALSO CCSCASE

-sin

: SELECT
  ?COMP
  #exits #level			\ preserve prior state
  short-branches?
  -short-branches		\ disable short branches
  ALSO CCSCASE			\ extend search order
  POSTPONE >R			\ runtime puts selector on return stack
  0 TO #EXITS			\ initialise state
  7 TO #LEVEL
; IMMEDIATE

ALSO CCSCASE DEFINITIONS

: OF
  ?COMP
  #LEVEL 7 = IF
    #LEVEL 2- TO #LEVEL
  ELSE
    POSTPONE ELSE
    #LEVEL 1- TO #LEVEL
  THEN
  POSTPONE R@
; IMMEDIATE

: CASE
  ?COMP
  #LEVEL 5 ?PAIRS
  POSTPONE IF
  #LEVEL 1+ TO #LEVEL
  #EXITS 1+ TO #EXITS
; IMMEDIATE

: DEFAULT
  ?COMP
  #LEVEL 7 = IF
    #LEVEL 2- TO #LEVEL
  ELSE
    POSTPONE ELSE
    #LEVEL 1- TO #LEVEL
  THEN
  POSTPONE TRUE
; IMMEDIATE

: CASEDONE
  ?COMP
  #LEVEL 6 ?PAIRS
  #EXITS 0 ?DO
    POSTPONE THEN
  LOOP
  POSTPONE R>
  POSTPONE DROP
  PREVIOUS
  if  +short-branches  else  -short-branches  endif
  -> #level  -> #exits
; IMMEDIATE

ONLY FORTH DEFINITIONS

+sin

