\ Extra USER variables
\ Last Revision: 20 Jan 2012  06:24:31  ward@megawolf.com
\ MacForth USER variables and some global variables
 
\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************



only Forth definitions
>M4TH

decimal

(( 

M4PLSTARTUP will auto-zero all between first and last below

MARKED FIRST AND LAST SHOULD BE LEFT AS SUCH

Additional ones you need can be added in between

Else they may have random values at startup

 ))


\ <size> +USER <name>

4 +user CURRENTPORT			\ <--- LEAVE THIS FIRST
4 +user CURRENTWINDOW
4 +user WINDOW.XFORM
4 +user mfCONSOLE			\ was CONSOLE
\ 4 +user TIBVAR
4 +user LAST.ERROR

4 +user STATUS
8 +user FOLLOWER

4 +user EVENTS
4 +user IO.EVENTS

\ 4 +user RETRY
4 +user DEBUG
4 +user TRACE				\  obsolete
4 +user UPDATE.STATUS		\  obsolete

\ 4 +user BLK

4 +user SPAN
4 +user CNTR
4 +user PNTR
4 +user OUTFILE
4 +user INFILE
4 +user PRTFILE
4 +user DEBUGFILE
\ 4 +user OWNPRINT


4 +user CREATOR
4 +user FILETYPE
8 +user CDIR		\ Current Directory info  ( 8 bytes)
4 +user ioDir		\ Oneshot Open/create optional Directory ID
4 +user VOLREF#		\ Oneshot Open/create Optional Volrefno
4 +user IO-RESULT
4 +user permissions

4 +user AlwaysSync		( for sync i/o )
4 +user SyncOnce		( for sync i/o )



\ 4 +user COL     		( OUTPUT COLUMN POINTER      *)
: COL OUT ;				\ alias/synonym for VFX USER var

4 +user Event.Filter
\ 4 +user mfLINE#		\ was LINE#

4 +user PRINTER			\ <--- LEAVE THIS LAST
						\ additional User variables you add must be Initialized
						\ on startup


s0 value ParentUserBase	\ 10.46 VALUE, not constant

((
S0 - first user variable



PRINTER - last user variable

4240 bytes User area
))


: ECHO (  -- addr |  Address of Console Table )
	mfconsole @ ;

: EOLN ( -- char )
	echo 1 + c@
;

\ : TIB ( -- addr of current TIB )
\	tibvar @ ;



variable SKIP.EVENTS	\ VERY DANGEROUS TO USE  !!!!!!!!!!!


\ ? make these USER ?  - probably not enough space available

create POCKET			512 allot&erase
create UPCASEPOCKET		512 allot&erase

\ these are references to our application inside our Bundle's Contents folder
create  MyNameBuffer 	256 allot&erase
0 value MyIODir 
0 value MyVolRef#


variable StartupToken   StartupToken off
variable TurnkeyToken	TurnkeyToken off
variable SnapshotToken	SnapshotToken off


 

\ *********************************************************
\ *********************************************************




StopIncluding ************************************

