\ FILE STUFF
\ Last Revision: 29 Feb 2012  16:45:33  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved.
\ Permission is hereby granted to VFX Forth for Mac customers
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited.
\ ***************************************************************************


((

Some new file stuff, some classic MF

we need a hodgepodge of file calls currently

	we have new style POSIX paths used by VFX file primitives
	we have a lot of old file words using Vol, DirID, name$
	we get FSSpec info from Navigation Services

	we want to know where 4th APP is
		app location  (inside the bundle)
		bundle location (containing folder that the user sees our app in)

	we want to be able to find our RESOURCES and other internal folders

	we need to be able to find our accessory files
		DEFAULT.EXTENSIONS
		our standard resources in 'RootResources.rsrc'
		resource bag if used
		nibs
		picts
		log file
		recent files

CommandLine  returns my full path name plus process ID

Interesting discussion at http://rixstep.com/2/2/20070718,00.shtml
))

only Forth definitions
>M4TH
decimal


Extern:  UInt32 OSStatus FSPathMakeRef (
   UInt32 * path
   UInt32 * FSRef
   UInt32 * isDirectory );
((
Convert a POSIX-style pathname into an FSRef structure.
path  A UTF-8 C string that contains the pathname to convert.
ref   A pointer to an FSRef structure allocated by the caller.
isDirectory A pointer to a Boolean variable allocated by the caller. This parameter is optional and may be NULL.
On output,
the FSRef structure refers to the object whose location is specified by the path parameter.
isDirectory true indicates the object is a directory.
))


\ To make a FSRef from a FSSpec
\		FSpMakeFSRef ( UInt32 * ^FSSpec, UInt32 * ^FSRef )

\ To obtain an FSSpec from an FSRef:
\		FSGetCatalogInfo ( &fsRef, kFSCatInfoNone, NULL, NULL, &fsSpec, NULL );

structure FSSpecRecord	( file system specification )	\ files.h
	short:	+FSSvRefNum	\	Integer;	{volume reference number}
	long:	+FSSparID	\	LongInt;	{directory ID of parent directory}
 63 string:	+FSSname	\	Str63;	{filename or directory name}
	10 +				\ all this structure is now opaque and totals $50 bytes
structure.end


((
(*
FSRef			RECORD 0
hidden			 ds.b	80		; offset: $0 (0)		;  private to File Manager
sizeof			 EQU *			; size:   $50 (80)
				ENDR
))


((
FSCatalogInfo			RECORD 0
nodeFlags				 ds.w	1				; offset: $0 (0)		;  node flags
volume					 ds.w	1				; offset: $2 (2)		;  object's volume ref
parentDirID				 ds.l	1				; offset: $4 (4)		;  parent directory's ID
nodeID					 ds.l	1				; offset: $8 (8)		;  file/directory ID
sharingFlags			 ds.b	1				; offset: $C (12)		;  kioFlAttribMountedBit and kioFlAttribSharePointBit
userPrivileges			 ds.b	1				; offset: $D (13)		;  user's effective AFP privileges (same as ioACUser)
reserved1				 ds.b	1				; offset: $E (14)
reserved2				 ds.b	1				; offset: $F (15)
createDate				 ds		UTCDateTime		; offset: $10 (16)		;  date and time of creation
contentModDate			 ds		UTCDateTime		; offset: $18 (24)		;  date and time of last fork modification
attributeModDate		 ds		UTCDateTime		; offset: $20 (32)		;  date and time of last attribute modification
accessDate				 ds		UTCDateTime		; offset: $28 (40)		;  date and time of last access (for Mac OS X)
backupDate				 ds		UTCDateTime		; offset: $30 (48)		;  date and time of last backup
permissions				 ds.l	4				; offset: $38 (56)		;  permissions (for Mac OS X)
finderInfo				 ds.b	16				; offset: $48 (72)		;  Finder information part 1
extFinderInfo			 ds.b	16				; offset: $58 (88)		;  Finder information part 2
dataLogicalSize			 ds		UInt64			; offset: $68 (104)		;  files only
dataPhysicalSize		 ds		UInt64			; offset: $70 (112)		;  files only
rsrcLogicalSize			 ds		UInt64			; offset: $78 (120)		;  files only
rsrcPhysicalSize		 ds		UInt64			; offset: $80 (128)		;  files only
valence					 ds.l	1				; offset: $88 (136)		;  folders only
textEncodingHint		 ds.l	1				; offset: $8C (140)
sizeof					 EQU *					; size:   $90 (144)


;  64 Bit Clock Typedefs
UTCDateTime				RECORD 0
highSeconds				 ds.w	1				; offset: $0 (0)
lowSeconds				 ds.l	1				; offset: $2 (2)  --> format by @clock
fraction				 ds.w	1				; offset: $6 (6)
sizeof					 EQU *					; size:   $8 (8)
						ENDR
))
Extern: UInt32 OSErr FSSetCatalogInfo ( UInt32 * &fsRef, UInt32 whichInfo, UInt32 * catalogInfo );
Extern: UInt32 OSErr FSGetCatalogInfo ( UInt32 * &fsRef, UInt32 whichInfo, UInt32 * catalogInfo,
										UInt32 * outName,  UInt32 * fsSpec, UInt32 * parentRef );

Extern: UInt32 OSerr FSpMakeFSRef ( UInt32 * ^FSSpec, UInt32 * ^FSRef );
Extern: UInt32 OSerr FSMakeFSSpec ( UInt32 volref#, UInt32 ioDir, UInt32 * ^fileName, UInt32 * ^FSSpec  );

Extern: UInt32 CFURLRef CFURLCreateFromFSRef ( UInt32 CFAllocatorRef, UInt32 * ^FSRef );

Extern: UInt32 CFURLRef CFURLCreateCopyDeletingLastPathComponent ( UInt32 CFAllocatorRef, UInt32 CFURLRef  );
Extern: UInt32 flag     CFURLGetFileSystemRepresentation ( UInt32 CFURLRef,
							UInt32 resolveAgainstBase?, UInt32 * ^buffer, UInt32 maxcnt );
Extern: UInt32 CFURLRef CFURLCreateFromFileSystemRepresentationRelativeToBase ( UInt32 CFAllocatorRef,
							UInt32 * ^buffer, UInt32 cnt, UInt32 isDirectory?, UInt32 baseCFURLRef  );
Extern: UInt32 CFURLRef CFURLCreateCopyAppendingPathComponent  ( UInt32 CFAllocatorRef,
							UInt32 BaseCFURLRef, UInt32 pathComponent, UInt32 isDirectory );

Extern: UInt32 CFURLRef CFURLCreateFromFileSystemRepresentation ( UInt32 allocator, UInt32 * buffer,
							UInt32 bufLen, UInt32 isDirectory );

\ Returns the last path component of a given URL.
Extern: UInt32 CFStringRef CFURLCopyLastPathComponent ( UInt32 CFURLRef );

\ Converts a given CFURLRef to a file or directory object.
Extern: UInt32 okflag CFURLGetFSRef ( UInt32 CFURLRef, UInt32 * ^FSRef );



extern: UInt32 osstatus LSOpenCFURLRef ( UInt32 CFURLRef, UInt32 ^CFURLRef );
/*
 *  Summary:
 *    Open an application, document, or folder.
 *
 *  Discussion:
 *    Opens applications, documents, and folders. Applications are
 *    opened via an 'oapp' or 'rapp' event. Documents are opened in
 *    their user-overridden or default applications as appropriate.
 *    Folders are opened in the Finder. Use the more specific
 *    LSOpenFromURLSpec for more control over launching.
 *
 *  Parameters:
 *
 *    inURL:
 *      The CFURLRef of the item to launch.
 *
 *    outLaunchedURL:
 *      The CFURLRef of the item actually launched. For inURLs that are
 *      documents, outLaunchedURL will be the application used to
 *      launch the document. Can be NULL. THIS FUNCTION, DESPITE ITS
 *      NAME, RETAINS THE URL REFERENCE ON BEHALF OF THE CALLER. THE
 *      CALLER MUST EVENTUALLY RELEASE THE RETURNED URL REFERENCE.
 */




CREATE StartupDir	\ default VolRefNum & DirID when MF+ starts
	0 ,  0 ,		\ a 2VARIABLE: DirID first, then VolRefNum



create	MyFSSpec							\ FSSpec of myself
			FSSpecRecord allot&erase

create	MyFSRef								\ FSRef of myself
			80 allot&erase

0 value	MyCFURL				\ CFURL of my mach-o app - DO NOT RELEASE THIS


\ scratch variables
create aFSRef    80 allot&erase
create isDir      0 ,
create aFSSpec   80 allot&erase
create Path$Buff 1024 allot&erase




((
: ShowCFURL ( CFURLRef -- )
	{ | str[ 1024 ] }
	1 str[ 1023 CFURLGetFileSystemRepresentation
	IF
		str[  zcount
		type
	ELSE
		." CFURLGetFileSystemRepresentation failed"
	THEN
;
 ))


: MakeCFURLfromPath ( addr\len -- CFURL )
	CFAllocatorGetDefault -rot 0 CFURLCreateFromFileSystemRepresentation
;


: CFUrl->ZString ( CFURL -- zstring )  \ CFURL NOT released !
\ uses Path$Buff so is only good transiently, like for a macro
	Path$Buff off
	1 Path$Buff 1023 CFURLGetFileSystemRepresentation
	IF
		Path$Buff 		\ dup s" /"  rot  appendz
	ELSE
		z" CFUrl->ZString failed"
	THEN
;


: CFUrl->CString ( CFURL -- cstring )  \ CFURL NOT released !
\ uses Path$Buff so is only good transiently, like for a macro
	CFUrl->ZString  asciiz>$
;


: ShowCFURL ( CFURLRef -- )  \ CFURL NOT released !
	CFUrl->ZString
	zcount type
;


: OpenCFURLRef ( CFURLRef -- OSerr )
	dup >R
	0 LSOpenCFURLRef
	R> CFRelease
;




: IsFileMissing? ( path$\cnt -- flag )	\ true if file no longer exists
	{ | FSRef[ 80 ] zPath[ 1024 ]  }
	zPath[ zplace	\ addr len zaddr --
	\ try to convert Path->FSRef
	isDir off
	zPath[ FSRef[ isDir FSPathMakeRef	\ result = 0 == ok
	0<>
;

\ navigating inside my bundle:

: GetCFURLofMyContents ( -- CFURL )
	\ remember to CFRelease when done with it
	\ CFURL of CONTENTS folder in MY bundle
	\ e.g. /Volumes/Development/PROGRAMMING/MPE/VfxRoot/MFonVFX.app/Contents  <-- no terminal /
	0 MyCFURL CFURLCreateCopyDeletingLastPathComponent
	dup >R 0 swap CFURLCreateCopyDeletingLastPathComponent
	R> CFRelease
;


: GetCFURLofMyResources ( -- CFURL )
	\ remember to CFRelease when done with it
	\ CFURL of folder enclosing RESOURCES in MY bundle i.e. CONTENTS folder
	\ e.g. /Volumes/Development/PROGRAMMING/MPE/VfxRoot/MFonVFX.app/Contents/Resources  <-- no terminal /

	CFAllocatorGetDefault			\ kCFAllocatorSystemDefault
	GetCFURLofMyContents dup >r		\ BaseCFURLRef
	over
	z" Resources/"
	kCFStringEncodingMacRoman
	CFStringCreateWithCString ( CFAllocatorRef\^0Str\CFStringEncoding -- CFStringRef )
	dup >R
	-1								\ isDirectory
	CFURLCreateCopyAppendingPathComponent  ( UInt32 CFAllocatorRef,
							UInt32 BaseCFURLRef, UInt32 pathComponent, UInt32 isDirectory )

	r> CFRelease					\ don't need CFStringRef
	r> CFRelease					\ don't need BaseCFURLRef
;


: GetCFURLofMyApp ( -- CFURL )
	\ remember to CFRelease when done with it
	\ CFURL of my app
	\ e.g. /Volumes/Development/PROGRAMMING/MPE/VfxRoot/MFonVFX.app
	0 MyCFURL CFURLCreateCopyDeletingLastPathComponent
	dup >R 0 swap CFURLCreateCopyDeletingLastPathComponent
	R> CFRelease
	dup >R 0 swap CFURLCreateCopyDeletingLastPathComponent
	R> CFRelease
;


: GetMyAppName ( Addr\len -- f )	\ true if successful
	GetCFURLofMyApp dup >R CFURLCopyLastPathComponent
	R> CFRelease
	dup >R -rot 0 CFStringGetPascalString
	R> CFRelease
;


: GetCFURLofMyApp'sFolder ( -- CFURL )
	\ remember to CFRelease when done with it
	\ CFURL of folder containing my bundle
	\ e.g. /Volumes/Development/PROGRAMMING/MPE/VfxRoot  <-- no terminal /
	GetCFURLofMyApp
	dup >R 0 swap CFURLCreateCopyDeletingLastPathComponent
	R> CFRelease
;


: SetCDtoMyFolder ( -- ioR )
	\ set System's Current Directory to our1 App's folder
	\ like cd in terminal - used by M4PLSTART1
	\ {  | path[ 1024 ] }
	GetCFURLofMyApp'sFolder dup >R
	CFUrl->ZString
	chdir
	\ true path[ 1023 CFURLGetFileSystemRepresentation
	\ IF
	\	path[ chdir
	\ ELSE
	\	-1
	\ THEN
	R> CFRelease
;



: CFURL->VolDir ( CFURL -- volref#\dirid )		\ DOES NOT CFRELEASE CFURL
	\ ENCLOSING dirid
	{  | scr[ 160 ] }
	scr[   160 erase
	scr[   FSSpecRecord +			\ *fsref
	CFURLGetFSRef
	IF
		scr[ FSSpecRecord +			\ *fsref
		0
		0
		0
		scr[						\ * FSSpec
		0
		FSGetCatalogInfo drop
		scr[ +FSSvRefNum w@s
		scr[ +FSSparID     @
	ELSE
		0 0
	THEN
;

: GetLocalVolDir ( -- volref#\dirid )
\ returns vol & dir where THIS copy of MFVFX is running
	GetCFURLofMyApp dup >R
	CFURL->VolDir ( CFURL -- volref#\dirid )
	R> CFRelease
;

: SetVolDirToLocal ( -- )
	GetLocalVolDir
	iodir ! volref# !
;


: FSSpec->CFURL ( ^FSSpec -- CFURL )
	\ remember to CFRelease when done with it
\ FILE MUST EXIST
	{ | fsref[ 80 ] }
	fsref[  FSpMakeFSRef  abort" FSpMakeFSRef error"
	CFAllocatorGetDefault fsref[ CFURLCreateFromFSRef
;


: FSSpec->ZString ( ^FSSpec -- zStr )	\ FSSpec -> Path
\ FILE MUST EXIST
\ useful for things like
\ NDFSSPec FSSpec->ZString zcount included
	FSSpec->CFURL dup
	CFUrl->ZString ( CFURL -- zstring )
	swap CFRelease
((
	1 Path$Buff 1023 CFURLGetFileSystemRepresentation
		0= abort" CFURLGetFileSystemRepresentation Error"
	Path$Buff
 ))
;


: FileInfo->ZString ( volref\iodir\file$ -- zStr |or| 0 )
\ empty file$ ( "" ) will return directory name
	{ | aFSSpec[ FSSpecRecord ] }
	aFSSpec[  FSMakeFSSpec  dup io-result !		\ abort" FSMakeFSSpec error"
	0=
	IF
		aFSSpec[  FSSpec->ZString
	ELSE
		0
	THEN
;


also substitutions

: ?ExtractMacro ( ^Fullpath\macroxt -- newpath\flag )	\ true if macro was extracted
	{ ^Fullpath macroxt }
	macroxt execute count 	dup >r	\ addr\cnt
	^Fullpath over
	istr=
	IF
		s" %"   				upcasepocket zplace
		macroxt >name count		upcasepocket zappend
		s" %"   				upcasepocket zappend
		^Fullpath r> + zcount	upcasepocket zappend
		upcasepocket
		true
	ELSE
		r> drop
		^Fullpath
		false
	THEN
;

variable AllowPathShortening	AllowPathShortening ON

: ?ShortenPath ( zstring -- zstring' )
	AllowPathShortening @ 0= IF exit THEN
	\ 10.46 - rename from ?StripDevpath and modify its function
	\ used by (INCLUDE..)  mfINCLUDE"  (SAVE&INCLUDE)
	\ MF Words that would otherwise pass a full path to INCLUDED
	\ this allows shorter and relocatable names to be added to SOURCEFILES
	\ see if it is in MFSOURCEPATH (normally within BASEPATH)

	\ check deepest nested folders first
	\ see if it is in VFX BIN = LOAD_PATH
	\ typically this is .../MacForthOnVFX/MFonVFX.app/Contents/MacOS/
	['] LOAD_PATH ?ExtractMacro 0=
	IF
		\ see if it is in MFSOURCEPATH
		['] MFSOURCEPATH ?ExtractMacro 0=
		IF
			\ see if it is in VFX LIB == LIBRARYDIR
			['] LIBRARYDIR ?ExtractMacro 0=
			IF
				\ see if it is in VFXPATH
				['] VFXPATH ?ExtractMacro 0=
				IF
					\ see if it is in BASEPATH
					['] BASEPATH ?ExtractMacro 0=
					IF
						\ see if it is in DEVPATH
						['] DEVPATH ?ExtractMacro drop
					THEN
				THEN
			THEN
		THEN
	THEN
;



((  tests
z" non existent file" ?ShortenPath zcount type
non existent file


z" %mfSourcePath%/MF Core/24 Events.fth" z$ExpandMacros  dup zcount type
cr ?ShortenPath zcount type

/Volumes/Development/PROGRAMMING/forth/PowerMacForth/PMF 6 Meta/x86 MacForth/MPE/VfxRoot/MacForthOnVFX/MF Core/24 Events.fth
%MFSOURCEPATH%/MF Core/24 Events.fth


z" %lib%//Osx32/MultiOsx32.fth" z$ExpandMacros  dup zcount type
cr ?ShortenPath zcount type

/Volumes/Development/PROGRAMMING/forth/PowerMacForth/PMF 6 Meta/x86 MacForth/MPE/VfxRoot/Lib//Osx32/MultiOsx32.fth
%LIBRARYDIR%//Osx32/MultiOsx32.fth


 ))



previous





: GetCatInfo  ( addr\cnt\namebuff\whichInfo\^catinfo --  aFSSpec |or| 0 ) 	\ 10.46
\ namebuff, whichinfo can be 0 to just get FSSpec
	{ namebuff whichInfo ^catinfo | FSRef[ 80 ] zPath[ 256 ]  }
	zPath[ zplace	\ addr len zaddr --
	aFSSpec 80 erase
\ first, convert Path->FSRef
	isDir off
	zPath[ FSRef[ isDir FSPathMakeRef	\ Converts a POSIX-style pathname into an FSRef structure
	IF
		0
	ELSE
\ then convert FSRef->FSSpec
		FSRef[
		whichInfo			\ kFSCatInfoNone
		^catinfo			\ whichInfo
		namebuff			\ ^outName - if we want a long name - note: 2 bytes per char - Unicode???
		aFSSpec
		0					\ parentRef
		FSGetCatalogInfo
		IF		\ 10.44
			0
		ELSE
			aFSSpec
		THEN
	THEN
;

: Path->FSSpec ( addr\cnt --  aFSSpec |or| 0 ) 	\ refactored 10.46
\ Posix path -> FSSpec
	0 0 0 GetCatInfo
;

((
: Path->FSSpec ( addr\cnt --  aFSSpec |or| 0 ) 	\ refactored 10.46
\ Posix path -> FSSpec
	{ | FSRef[ 80 ] zPath[ 256 ]  }
	zPath[ zplace	\ addr len zaddr --
	aFSSpec 80 erase
\ first, convert Path->FSRef
	isDir off
	zPath[ FSRef[ isDir FSPathMakeRef	\ Converts a POSIX-style pathname into an FSRef structure
	IF
		0
	ELSE
\ then convert FSRef->FSSpec
		FSRef[
		0					\ kFSCatInfoNone
		0					\ whichInfo
		0 					\ ^outName - if we want a long name - note: 2 bytes per char - Unicode???
		aFSSpec
		0					\ parentRef
		FSGetCatalogInfo
		IF		\ 10.44
			0
		ELSE
			aFSSpec
		THEN
	THEN
;
 ))





extern: UInt32 OSStatus LSCopyItemInfoForRef ( UInt32 FSRef,    UInt32 inWhichInfo, UInt32 * outItemInfo );
((
LSItemInfoRecord		RECORD 0
flags					 ds.l	1				; offset: $0 (0)
filetype				 ds.l	1				; offset: $4 (4)
creator					 ds.l	1				; offset: $8 (8)		;  release when finished
extension				 ds.l	1				; offset: $C (12)		;  release when finished
iconFileName			 ds.l	1				; offset: $10 (16)		;  unupported
kindID					 ds.l	1				; offset: $14 (20)		;  unupported
sizeof					 EQU *					; size:   $18 (24)
						ENDR

typedef OptionBits                      LSItemInfoFlags;
enum {
  kLSItemInfoIsPlainFile        = 0x00000001, /* Not a directory, volume, or symlink*/
  kLSItemInfoIsPackage          = 0x00000002, /* Packaged directory*/
  kLSItemInfoIsApplication      = 0x00000004, /* Single-file or packaged application*/
  kLSItemInfoIsContainer        = 0x00000008, /* Directory (includes packages) or volume*/
  kLSItemInfoIsAliasFile        = 0x00000010, /* Alias file (includes sym links)*/
  kLSItemInfoIsSymlink          = 0x00000020, /* UNIX sym link*/
  kLSItemInfoIsInvisible        = 0x00000040, /* Invisible by any known mechanism*/
  kLSItemInfoIsNativeApp        = 0x00000080, /* Carbon or Cocoa native app*/
  kLSItemInfoIsClassicApp       = 0x00000100, /* CFM/68K Classic app*/
  kLSItemInfoAppPrefersNative   = 0x00000200, /* Carbon app that prefers to be launched natively*/
  kLSItemInfoAppPrefersClassic  = 0x00000400, /* Carbon app that prefers to be launched in Classic*/
  kLSItemInfoAppIsScriptable    = 0x00000800, /* App can be scripted*/
  kLSItemInfoIsVolume           = 0x00001000, /* Item is a volume*/
  kLSItemInfoExtensionIsHidden  = 0x00100000  /* Item has a hidden extension*/
};

))

: GetInfoForRef ( vol dir name -- flags filetype creator )
	{ | aFSSpec[ FSSpecRecord ] aFSRef[ 80 ] ItemInfo[ 24 ] }

	count 63 min  aFSSpec[ +FSSname  place
	aFSSpec[ +FSSparID   !
	aFSSpec[ +FSSvRefNum w!

	aFSSpec[ aFSRef[ FSpMakeFSRef   				\ abort" FSpMakeFSRef error"
	IF	0 0 0 exit THEN
	aFSRef[ $FFFFFFFF ItemInfo[ LSCopyItemInfoForRef \  abort" LSCopyItemInfoForURL error "
	IF
		0 0 0
	ELSE
		ItemInfo[ @				\ flags
		ItemInfo[ 4 + @			\ filetype
		ItemInfo[ 8 + @			\ creator
	THEN
;




\ some old stuff
\ For the Carbon file words, use ':' instead of '/' to dilineate directories !


: RO  1 permissions ! ;		\ read-only
: WO  2 permissions ! ;		\ write-only
: RW  3 permissions ! ;		\ read/write
: RWSH  4 permissions ! ;	\ read and write shared


Extern: UInt32 OSErr HSetVol ( UInt32 * volName, UInt32 vRefNum, UInt32 dirID );
Extern: UInt32 OSErr HGetVol ( UInt32 * volName, UInt32 * vRefNum, UInt32 dirID );


: DirGet  ( -- VolRefNum\DirID )  \ identifies current default V & D
	{  |  localbuf[ 52 ] }
	localbuf[ 52 erase
	localbuf[  PBHGetVolSync io-result !
	\ this is sure to get true vrefnum & dirID (not wd refnum)
	localbuf[ 32 + w@s
	localbuf[ 48 + @ ;


: DirSet  ( VolRefNum\DirID -- )  \ becomes default V & D
	2dup IODir ! VolRef# !
	0 -rot HSetVol io-result ! ;



Extern:  UInt32 OSErr PBGetCatInfoSync  ( UInt32 * &CInfoPB );
Extern:  UInt32 OSErr PBGetCatInfoAsync ( UInt32 * &CInfoPB );

AliasedExtern: _GetVRefNum  UInt32 OSErr GetVRefNum  ( UInt32 fRefNum, UInt32 VRefNum  );
\ Extern:  UInt32 OSErr GetVRefNum  ( UInt32 fRefNum, UInt32 VRefNum  );
\ : _GetVRefNum GetVRefNum ;

: GetVRefNum ( fRefNum -- vRefNum\flag )
	0 >R RP@ _GetVRefNum dup io-result !
	R> 16 rshift swap ;


Extern:  UInt32 OSErr HOpen  ( UInt32 vRefNum, UInt32 dirID, UInt32 *fileName,
			UInt32 permission, UInt32 * &refNum );
Extern:  UInt32 OSErr HCreate  ( UInt32 vRefNum, UInt32 dirID, UInt32 *fileName, UInt32 creator, UInt32 fileType );
Extern:  UInt32 OSErr FSClose  ( UInt32 RefNum  );

Extern:  UInt32 OSErr HDelete  ( UInt32 vRefNum, UInt32 dirID, UInt32 *fileName  );

Extern:  UInt32 OSErr PBReadSync    ( UInt32 * &pb );
Extern:  UInt32 OSErr PBReadAsync   ( UInt32 * &pb );
Extern:  UInt32 OSErr PBWriteSync   ( UInt32 * &pb );
Extern:  UInt32 OSErr PBWriteAsync  ( UInt32 * &pb );

AliasedExtern: _SetEOF  UInt32 OSErr SetEOF   ( UInt32 fRefNum, UInt32 newEOF  );
\ Extern:  UInt32 OSErr SetEOF   ( UInt32 fRefNum, UInt32 newEOF  );
Extern:  UInt32 OSErr GetEOF   ( UInt32 fRefNum, UInt32 * &curEOF );
AliasedExtern: _GetFPos  UInt32 OSErr GetFPos  ( UInt32 fRefNum, UInt32 * &position );
\ Extern:  UInt32 OSErr GetFPos  ( UInt32 fRefNum, UInt32 * &position );
AliasedExtern: _SetFPos UInt32 OSErr SetFPos  ( UInt32 fRefNum, UInt32 posModem, UInt32 posOffset );
\ Extern:  UInt32 OSErr GetFPos  ( UInt32 fRefNum, UInt32 * &position );

: SetEOF			( FileRefNo\newsize -- ioresult )
	_SetEOF dup io-result ! ;			\ sets new end of file. ioresult is returned

: GetFPos		( FileRefNo -- PosOffset )
	0 >R RP@ _GetFPos io-result ! R> ;	\ Returns current file position relative to
										\ start of file
: SetFPos		( FileRefNo\PosMode\PosOffset -- ioresult )
	_SetFPos dup io-result ! ;		\ seeks to desired file position



Extern:  UInt32 OSErr PBFlushFileAsync ( UInt32 * paramBlock );
Extern:  UInt32 OSErr PBFlushFileSync ( UInt32 * paramBlock );
\ Extern:  UInt32 OSErr FlushVol ( UInt32 * volname, UInt32 vRefNum );
Extern:  UInt32 OSStatus  FSFlushVolume ( UInt32 * vRefNum );



1 constant FROM.START
1 constant VIRTUAL
2 constant FROM.END
3 constant FROM.CURRENT	\ from mark with offset

64 constant RDVERIFY		\ add to above to force auto-verification

: CURRENT.POSITION  ( file# -- offset from start of file to mark )
	GetFPos ;

: POINT  ( mode\offset\file# -- )
	-rot SetFPos  io-result ! ;

: REWIND  ( file# -- )
	from.start 0 rot point ;

: FILESIZE?    ( fileid -- size )
	0 >R RP@ GetEOF io-result ! R> ;

: GET.EOF  ( file# -- # bytes )
	filesize? ;

: SET.EOF  ( #bytes\file# -- )
	swap SetEof  io-result ! ;


0 value dfltVolRef#
0 value dfltIODir


: VolDirExpires  ( -- )
	dfltVolRef# extend volref# !
	dfltIODir          iodir   !
\	permissions off ;	\ one-shots
	-1 permissions ! ;	\ one-shots

defer AfterOpenAction  ( p$name\fileID --  )
	' 2DROP IS AfterOpenAction

defer BeforeCloseAction  ( fileID --  )
	' DROP IS BeforeCloseAction

\ : @VOLREF# ( -- vref# )
\	volref# 2 + w@s ;


: <<OPEN         ( p$name -- fileid )
	dup
	volref# @ extend					\	@VOLREF#
	iodir @ rot permissions @
	0 >R RP@ HOpen io-result ! R> 		\ 16 rshift	\ rashift
										\ p$name\fileid
\ OSX can return a non-0 Ref# id even with an error
	io-result @ ?dup
	IF
		-49 = FALSE= IF drop 0 THEN 	\ ?? ignore "File already open" error
	THEN

	\ " after _HOpen "  "" "" "" 806 DfltISSUEALERT drop
	dup 0>
	IF   tuck AfterOpenAction ( p$name\fileID --  )
	ELSE nip
	THEN
	VolDirExpires						\ one-shots
;


defer OPEN$  ( name$ -- file# )
	'	<<OPEN	is OPEN$


: <<CLOSE        ( fileid -- )
	dup BeforeCloseAction
	FSClose io-result ! ;


: <CLOSE ( file# -- | OVERLOAD )	\ change this from CLOSE in 6.04994
	dup  GetVRefNum		\ file#\vrefNum\valid?
	rot <<close
	IF
		drop
	ELSE
		drop	\		0 swap FlushVol2	\ ?obsolete
	THEN ;


defer FILECLOSE  ( file# --  )
	' <CLOSE	is FILECLOSE



: <<NEW.FILE     ( p$name -- fileid)
	dup
	volref# @ extend
	iodir @ rot creator @ filetype @
	HCreate dup io-result !
	0= IF <<OPEN ELSE drop 0 VolDirExpires THEN ;


: <NEW.FILE ( size\name$ -- file# | OVERLOAD )	\ change this from NEW.FILE in 6.04994
    locals| TheName$ TheSize |
	TheName$ <<new.file
	io-result @ 0=
	IF  dup TheSize SetEof
		io-result !
	THEN ;


defer NEW.FILE  ( size\name$ -- file# )
	' <NEW.FILE IS NEW.FILE



: Sync?  ( -- flag )	\ Clears the SYNCONCE one-short
	alwaysSync @ syncOnce @ OR
	syncOnce off ;


: SYNC  ( -- )
	-1 syncOnce ! ;	\ Sets the one-shot


: WaitForIOCompletion  ( &pb -- ioResult )
	BEGIN
		dup 16 +
		w@s 0>			\ <w@ 0>
	WHILE
		pause
	REPEAT				\ wait for ioResult to be <=0
	16 + w@s ;		\ <w@ ;


: GetFCBInfo ( ^namePtr\fileRef# -- VolRefNum\DirID\flags )
	\ Use to get info from a fileRef#
	\ Returns SHORT file names - not Unicode version
	\ data at namePtr is changed
	\ namePtr can be 0
	{ | fcb[ 126 ] }
	fcb[ 126 erase
	fcb[ 24 + w!	\ ioRefNum		ds.w	1	; offset: $18 (24)
	fcb[ 18 + !		\ ioNamePtr		ds.l	1	; offset: $12 (18)
	fcb[ PBGetFCBInfoSync io-result !
	fcb[ 52 + w@s	\ ioFCBVRefNum	ds.w	1	; offset: $34 (52)
	fcb[ 58 + @		\ ioFCBParID	ds.l	1	; offset: $3A (58)
	fcb[ 36 + w@	\ ioFCBFlags	ds.w	1	; offset: $24 (36)
		8 rshift	\ ENDIAN
;
((
kioFlAttribLockedBit			EQU		0		; Set if file or directory is locked
kioFlAttribResOpenBit			EQU		2		; Set if resource fork is open
kioFlAttribDataOpenBit			EQU		3		; Set if data fork is open
kioFlAttribDirBit				EQU		4		; Set if this is a directory
ioDirFlg						EQU		4		; Set if this is a directory (old name)
kioFlAttribCopyProtBit			EQU		6		; Set if AppleShare server "copy-protects" the file
kioFlAttribFileOpenBit			EQU		7		; Set if file (either fork) is open
kioFlAttribInSharedBit			EQU		2		; Set if the directory is within a shared area of the directory hierarchy
kioFlAttribMountedBit			EQU		3		; Set if the directory is a share point that is mounted by some user
kioFlAttribSharePointBit		EQU		5		; Set if the directory is a share point
))


: GetFileName  ( namePtr\fileID -- )
	GetFCBInfo 3drop ;


: GetDirFromRef# ( ref# -- VolRefNum\DirID )
	0 swap GetFCBInfo drop
;


: FLUSH.VOL  ( file# -- )
	GetVRefNum
	IF
		drop	\ ignore error
	ELSE
		FSFlushVolume
	THEN ;


: FLUSH.FILE  ( file# -- )
	{ | thePCB[ 80 ] }
	thePCB[ 80 erase
	thePCB[ 24 + w!		\ ioRefNum
	sync? IF
		thePCB[ PBFlushFileSync io-result !
	ELSE
		thePCB[ PBReadAsync drop
		thePCB[ WaitForIOCompletion io-result !
	THEN
;


: ?Open  ( fileID -- flag )				\ almost silly - use it to check for bad ref#'s
	0 swap GetFCBInfo 3drop
	io-result @ 0=  ;


: ?FileLocked  ( fileID -- flag)		\  was ?ReadOnly 	\ also silly - is true if we opened RW, false if not
	0 swap GetFCBInfo  nip nip
	1 and  0<>
;


126 constant PCB.LEN ( big enough for any use )

: MAKE.PCB  ( -- [locked, erased PCB handle] or [0] )
	PCB.Len \ byteHandle? if
	MakeHandle ?dup
	IF
		\ handle is already cleared, lock it
		dup HLock		\ give back the handle
	else
		136 io-result !		\ out of memory
		0
	then ;


\ High-level version of _PBGetCatInfo
\ Returns info about a file or a directory as specified by
\   a name or an index.
\ Recently "deprecated" by Apple in favor of _PBGetCatalogInfoSync
\	which is NOT indexed, but does use the more versatile FSRef for
\	specifying the target file, allowing use of 255 character Unicode file names
: GET.CAT.INFO  ( vRefNum\DirID\namePtr\index -- [unlocked PCB handle] or [0] )
	\ BE CAREFUL!  The namePtr parameter is MODIFIED by this word.
	make.pcb dup locals| pcbHandle |
	IF
		pcbHandle @
			tuck 28 +  w!		\ ioFDirIndex
			tuck 18 + !			\ ioNamePtr
			tuck 48 + !			\ ioDirID
			tuck 22 + w!		\ ioVRefNum
		sync? IF
			PBGetCatInfoSync io-result !
		ELSE
			dup PBGetCatInfoAsync drop
			    WaitForIOCompletion io-result !
		THEN
		pcbHandle HUnlock
	ELSE 2drop 2drop
	THEN
	pcbHandle ;


((
: LatestIncludedFileName ( -- str$ )	\ gets name from VFX vocab
	['] sourcefiles voc>wid (max-def)  nip 1+
;
))

: LatestFileDir ( -- VRef#\DirID )
	\ gets VolRef# and IoDir for file being included
	{ | FSRef[ 80 ] zPath[ 256 ]  }
	\ LatestIncludedFileName  count
	CurrSourceName	\ -- c-addr u
	expand 								\ 10.46
	path->fsspec   ?dup
	IF
		\ dup  +FSSname cr  count type
		dup  +FSSvRefNum w@s
		swap +FSSparID	@
	ELSE	\ oops
		0 0
	THEN
;


: mfINCLUDE" 	\ use volref# & iodir and short file name
	{ | name$[ 255 ]  }

	ascii " parse-word			\ char -- c-addr u
	name$[ place

	volref# @ iodir @ name$[
	FileInfo->ZString ( volref\iodir\file$ -- zStr )
	?dup 0= abort" file not found"
\	cr ." ** including file = "  dup zcount type cr
	?ShortenPath					\ 10.44
	zcount included
;


: MyFOLDER ( -- | sets VolRef# and DirID to same folder as infile )
	'SourceFile 0= abort" Only use MyFOLDER while loading a file"
	LatestFileDir
	iodir !  volref# !
;


: FileREAD         ( addr\cnt\file# --  #read )
	100 NewPtrClear
	tuck 24 + w!			\ ioRefNum
	tuck 36 + !				\ ioReqCount
	tuck 32 + !				\ ioBuffer
	sync?
	IF
		dup PBReadSync io-result !
	ELSE
		dup PBReadAsync drop
  		dup WaitForIOCompletion io-result !
	THEN
	dup 40 + @				\ get ioActCount
	swap DisposePtr
;

((  CMF version
: READ-LINE  ( c-addr\u1\fileid -- u2\flag\ior )
	2 pick >R	\ save buffer addr
	read.text iocount @ ?dup IF
		R> + 1- c@ 13 = IF -1 iocount +! THEN	\ don't count EOF
		true
	ELSE R>drop false THEN
	iocount @ swap
	io-result @ dup -39 = IF drop 0 THEN ;	\ eof is not really an error
 ))


: READ.TEXT   ( addr\cnt\file# --  #read )
\ uses EOLN
	100 NewPtrClear
	tuck 24 + w!		\ ioRefNum
	tuck 36 + !			\ ioReqCount
	tuck 32 + !			\ ioBuffer
	\ ENDIAN - REVERSE THESE !
	\ EOLN over 44 + c!	\ ioPosMode = newline mode, 3456 = 0x0d80
	\ 128  over 45 + c!	\ ioPosMode = newline mode, 3456 = 0x0d80
	EOLN over 45 + c!	\ ioPosMode = newline mode, 3456 = 0x0d80
	128  over 44 + c!	\ ioPosMode = newline mode, 3456 = 0x0d80
	sync? IF
		dup PBReadSync io-result !
	ELSE
		dup PBReadAsync drop
		dup WaitForIOCompletion io-result !
	THEN
	dup 40 + @				\ get ioActCount
	swap DisposePtr
;
((
fsAtMark						EQU		0					; positioning modes in ioPosMode
fsFromStart						EQU		1
fsFromLEOF						EQU		2
fsFromMark						EQU		3

															; ioPosMode flags
pleaseCacheBit					EQU		4					; please cache this request
pleaseCacheMask					EQU		$0010
noCacheBit						EQU		5					; please don't cache this request
noCacheMask						EQU		$0020
rdVerifyBit						EQU		6					; read verify mode
rdVerifyMask					EQU		$0040
rdVerify						EQU		64					; old name of rdVerifyMask
forceReadBit					EQU		6
forceReadMask					EQU		$0040
newLineBit						EQU		7					; newline mode
newLineMask						EQU		$0080
newLineCharMask					EQU		$FF00				; newline character

ioPosMode				 ds.w	1				; offset: $2C (44)		; initial file positioning
ioPosOffset				 ds.l	1				; offset: $2E (46)		; file position offset

))

: FILEWRITE  ( addr\cnt\file# --  #written )
	100 NewPtrClear
	tuck 24 + w!		\ ioRefNum
	tuck 36 + !			\ ioReqCount
	tuck 32 + !			\ ioBuffer
	sync? IF
		dup PBWriteSync io-result !
	ELSE
		dup PBWriteAsync drop
		dup WaitForIOCompletion io-result !
	THEN
	dup 40 + @				\ get ioActCount
	swap DisposePtr
;


: xFILEWRITE  ( addr\cnt\file# --  #written )
	drop swap drop
;



: Prim?TERMINAL   (   -- N    N = 0 IF NO CHAR REC'D )	\ 5.2
	1 ;		\ ?? check for infile = 0   or  EOF



defer DfltWRITE  ( addr\cnt\file# --  #written )
	' xFileWrite IS DfltWRITE



: PrimEXPECT     ( ADDR\COUNT -- #RECEIVED ) \ 5.2 -- return 0 if infile = 0
	infile @ dup IF Read THEN ;

: PrimKEY        (   --  keystroke )
	0 >R rp@ 1 PrimExpect IF R> ELSE R> drop 0 THEN ;



: DfltTYPE  ( addr\cnt --  )
	outfile @ ?dup IF DfltWRITE ELSE nip THEN col +! ;


: DfltPRINT  ( addr\cnt --  )
	prtfile @ ?dup IF DfltWRITE ELSE nip THEN col +! ;


: DfltEPRINT  ( addr\cnt --  )
	io.events @ >r			\ ???? turn SKIP.EVENTS ON instead ????
	io.events off
	debugfile @ ?dup
	IF   DfltWRITE drop
	ELSE 2drop	\ <type		\ do NOTHING if DebugFile is OFF  !!!
	THEN
	r> io.events !  ;



\ ************************************************************************


\ see Folders.h

\ -32767 constant kOnAppropriateDisk	\ typically system disk
-32763 constant kUserDomain

((  many others available - these seem especially useful
  kCurrentUserFolderType        = 'cusr', /* The folder for the currently logged on user; domain passed in is ignored. */
  kApplicationSupportFolderType = 'asup', /* third-party items and folders */
  kDesktopFolderType            = 'desk', /* the desktop folder; objects in this folder show on the desktop. */
  kTrashFolderType              = 'trsh', /* the trash folder; objects in this folder show up in the trash */
  kPreferencesFolderType        = 'pref', /* preferences for applications go here */
  kApplicationsFolderType       = 'apps', /*    Applications on Mac OS X are typically put in this folder ( or a subfolder ).*/
  kSharedUserDataFolderType     = 'sdat' /* A Shared folder, readable & writeable by all users */
))

extern: UInt32 OSErr FindFolder (
  UInt32 vRefNum,
  UInt32 folderType,
  UInt32 createFolder,
  UInt32 * foundVRefNum,
  UInt32 * foundDirID ) ;


: FolderType->VolDir ( folderType -- ioR )
\ set volref# & ioDir to point to the specified folder in the Read/Writeable user domain
\ many folders are also available at the root level, but read only
	kUserDomain
	swap
	0				\ don't create
	volref# ioDir
	FindFolder ;

: Home->VolDir ( folderType -- ioR )
\ set volref# & ioDir to point to '/Users/<you>'
	ascii cusr FolderType->VolDir
;

: AppSupport->VolDir ( folderType -- ioR )
\ set volref# & ioDir to point to local Application Support
	ascii asup FolderType->VolDir
;


: ApplicationSupportFolderZ$ ( -- zstring |or| 0 )
\ returns path to Appplication Support Folder
\ should be correct for any OS Language
\ /Users/ward/Library/Application Support
\ uses Path$Buff so should plenty of room to append to the string in situ
	AppSupport->VolDir
	IF
		0
	ELSE
		volref# w@s ioDir @ ""
		FileInfo->ZString
	THEN
;


create MyAppSuppFolder$ 128 allot&erase

\ Apple suggests using Bundle Indentifier from info.plist for the name
\ of our Application Support subfolder, but almost no-one does that
	s" /VfxForth" MyAppSuppFolder$ place		\ 10.46
\	s" /VfxForth/" MyAppSuppFolder$ place


: MyApplicationSupportFolderZ$ ( -- zstring |or| 0 )
\ e..g. /Users/ward/Library/Application Support/VfxForth/
	ApplicationSupportFolderZ$ ?dup
	IF
		dup MyAppSuppFolder$ count rot zappend
	THEN
;


: CreateMyApplicationSupportDir ( -- )
\ harmless to do if it already exists
	MyApplicationSupportFolderZ$ ?dup
	IF
		511 ( octal 777 ) mkdir drop
	THEN
;

: GetMyAppSupportVolDir ( -- volref#\dirid )
	CreateMyApplicationSupportDir
	MyApplicationSupportFolderZ$ zcount
	Path->FSSpec ?dup
	IF
		dup  +FSSvRefNum w@s
   	 swap +FSSparID @
    ELSE
    	0 0
    THEN
;

: SetVolDirToMyAppSupport ( -- )
	GetMyAppSupportVolDir
	iodir ! volref# !
;



\ A few handy MACROS:

also substitutions definitions
: MyAppSupportPath ( -- caddr )
	MyApplicationSupportFolderZ$
	asciiz>$
;

: MyContentsPath ( -- caddr )
	GetCFURLofMyContents dup >R
	CFUrl->CString
\	dup s" /" rot append	\ 10.46
	R> CFRelease
;

: MyResourcesPath ( -- caddr )
	GetCFURLofMyResources dup >R
	CFUrl->CString
\	dup s" /" rot append	\ 10.46
	R> CFRelease
;

: MyLocalPath ( -- caddr )
	GetCFURLofMyApp'sFolder dup >R
	CFUrl->CString
\	dup s" /" rot append	\ 10.46
	R> CFRelease
;
>m4th
((
s" %MyContentsPath%/Extras" expand  type
/Volumes/Development/PROGRAMMING/MPE/VfxRoot/MFonVFX.app/Contents/Extras


s" %MyResourcesPath%/Dirty Picture" expand  type
/Volumes/Development/PROGRAMMING/MPE/VfxRoot/MFonVFX.app/Contents/Resources/Dirty Picture


s" %MyLocalPath%/local" expand  type
/Volumes/Development/PROGRAMMING/MPE/VfxRoot/local


s" %MyAppSupportPath%/Recent Files" expand type

/Users/ward/Library/Application Support/VfxForth/Recent Files
))









StopIncluding ************************************

