\ Resource Bag
\ Last Revision: 11 May 2012  11:32:41  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************



((

Open Resource files in our ../XXXX.app/Contents/Resources/    folder

Currently we keep MF resources (the ones we kept in our app as well as in Resource Bag in
 	../XXXX.app/Contents/Resources/RootResources.rsrc
which is opened in  M4PLSTART1 at startup

Consider building a chain of named resource files

And possibly a more easily accssible traditional Resource Bag at our app level, not buried inside

))


only forth definitions

\ anew --contents--

>m4th 



: OpenResourcesFile ( cname$ -- file# )	\ resopen file in RESOURCES folder
	{: cname$ | name$[ 256 ] :}
	
	GetCFURLofMyResources 
		dup cfurl->voldir
		rot CFRelease					\ leave out the ROT for major repeating SIGSEGV errors
	
	s" :RESOURCES:" name$[ place		\ old-style file calls use : not /
	cname$ count    name$[ append

	name$[ permissions @ HOpenResFile
;


: UseResourcesFile ( cname$ -- file#\reserror )	\ 10.45 Open and USE file in RESOURCES folder
\ : UseResourcesFile ( cname$ -- reserror )	\ Open and USE file in RESOURCES folder
	dup RW OpenResourcesFile dup			\ first try RW
	0>										\ 10.45
	IF
		nip									\ success, discard cname$
	ELSE
		drop
		RO OpenResourcesFile				\ failing RW, try RO
	THEN
	dup										\ 10.45
	ResError dup >R
	0=
	IF
		useresfile
	ELSE
		drop
	THEN
	R>
;

