\ Demo ChainOfChains & autopruning of its offspring
\ Last Revision: 12 Dec 2011  22:09:07  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


((

Include this file and try the examples at the end of this file

))

Only Forth definitions

anew --chaintest--

>m4th


: ABC  cr ."   bye bye  !!" ;  on.forget abc



mfchain TestChain1
mfchain TestChain2
mfchain TestChain3


marker m1

: Sub1.1
	cr ." sub1.1 " ;   TestChain1 LinkLastToken

: Sub1.2
	cr ." sub1.2 " ;   TestChain2 LinkLastToken

: Sub1.3
	cr ." sub1.3 " ;   TestChain3 LinkLastToken


marker m2

: Sub2.1
	cr ." sub2.1 " ;   TestChain1 LinkLastToken

: Sub2.2
	cr ." sub2.2 " ;   TestChain2 LinkLastToken

: Sub2.3
	cr ." sub2.3 " ;   TestChain3 LinkLastToken


: ON.FORGET.TEST2
	beep cr ." executing ON.FORGET.TEST2"
; on.forget ON.FORGET.TEST2


marker m3

: Sub3.1
	cr ." sub3.1 " ;   TestChain1 LinkLastToken

: Sub3.2
	cr ." sub3.2 " ;   TestChain2 LinkLastToken

: Sub3.3
	cr ." sub3.3 " ;   TestChain3 LinkLastToken


marker m4

: Sub4.1
	cr ." sub4.1 " ;   TestChain1 LinkLastToken

: Sub4.2
	cr ." sub4.2 " ;   TestChain2 LinkLastToken

: Sub4.3
	cr ." sub4.3 " ;   TestChain3 LinkLastToken


: S1
	on.forget.linkage showmfchain ;



StopIncluding ************************************



---> select each of the next 2 lines and press ENTER

ShowCoC		\ show chain of chains


DetailCoC


---> then delete the tails using one of the markers

M4

DetailCoC


---> then delete more of the tails using another marker

M2		\ note one of the ON.FORGET words is in the forgotten range
		\ and it gets executed

DetailCoC

