\ Finger Paint example from the PowerMacForth manual
\ Last Revision: 10 Jan 2012  11:53:06  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************

only FORTH Definitions
decimal

anew demomarker

>m4th

new.window sheet
	C" Finger Paint Window"		sheet w.title
	60 5 200 300				sheet w.bounds
	size.box close.box +		sheet w.attributes
having kWindowCollapseBoxAttribute  kWindowCollapseBoxAttribute sheet NewWAttributes  \ 6.053
	sys.window					sheet w.behind


: TRACE.FINGER
	ObscureCursor	\ HideCursor
	BEGIN
		StillDown
	WHILE
		@mousexy dot
	REPEAT
	ShowCursor ;


: FINGER.PAINT  ( activate flag -- )
	IF
		BEGIN
			DO.EVENTS
			CASE
				mouse.down  OF trace.finger ENDOF
				in.size.box OF page ENDOF
			ENDCASE
		AGAIN
	ELSE
		Beep
	THEN ;
sheet on.activate finger.paint


15 constant FINGER.SIZE.MENU

: DO.FINGER.MENU  ( item# -- )
	0 HiliteMenu
	Get.Window >R sheet window
	case
		1 of 1 1 PenSize endof
		2 of 3 3 PenSize endof
		3 of 5 5 PenSize endof
	endcase
	r> window ;


: FINGER.MENU  ( -- )
	finger.size.menu  delete.menu
	0 C" Finger Size"      FINGER.SIZE.MENU NEW.MENU
	C" Small;Medium;Large" FINGER.SIZE.MENU append.items
	DrawMenuBar
	FINGER.SIZE.MENU menu.selection: do.finger.menu ;


finger.menu

sheet add.window
