\ Show using non-command key modifiers
\ Last Revision: 17 Apr 2012  16:33:01  ward@megawolf.com


(( 

OS X allows menu selection using only Option, Control, or Shift keys
As well as combinations

Our old method detected Command Key only as menu selector.

This file demonstrates using some of the other possibilites


I am not sure why anyone would want to remap Shift-X to the menubar instead of
a capital letter, but who knows?  It is allowed and we now support it.

 ))



only forth definitions

anew --menutest--
>m4th



21 value testmenu#



: DO.TEST.MENU ( item -- )   beep
	0 hilitemenu
	s.cr
	CASE
		1 OF  s" cmd key" 		   s.type s.cr	ENDOF
		2 OF  s" cmd+shift key"    s.type s.cr	ENDOF
		3 OF  s" cmd+option key"   s.type s.cr	ENDOF
		4 OF  s" cmd+control key"  s.type s.cr	ENDOF
		5 OF  s" only shift key"   s.type s.cr	ENDOF
		6 OF  s" only option key"  s.type s.cr	ENDOF
		7 OF  s" only control key" s.type s.cr	ENDOF
	ENDCASE ;


(*
SET.ITEM.MODIFIERS ( item\modifer\menu.id -- )

	kMenuNoModifiers If no bit is set, only the Command key is used in the
	keyboard equivalent. 
	
	kMenuShiftModifier If this bit (bit 0) is set, the Shift key is used in the
	keyboard equivalent. 
	
	kMenuOptionModifier If this bit (bit 1) is set, the Option key is used in
	the keyboard equivalent. 
	
	kMenuControlModifier If this bit (bit 2) is set, the Control key is used in
	the keyboard equivalent. 
	
	kMenuNoCommandModifier If this bit (bit 3) is set, the Command key is not
	used in the keyboard equivalent. 
*)



: AddTestMenu
	testmenu#  1stFreeMenu# -> testmenu#
	testmenu# C" TestMenu" testmenu# new.menu
	
	C" Test CmdKey/Y" testmenu# append.items
	
	C" Test +ShiftKey/Y" testmenu# append.items
			2 1 testmenu# set.item.modifiers ( item\modifer\menu.id -- )
	C" Test +OptKey/Y" testmenu# append.items
			3 2 testmenu# set.item.modifiers ( item\modifer\menu.id -- )
	C" Test +CtrlKey/Y" testmenu# append.items
			4 4 testmenu# set.item.modifiers ( item\modifer\menu.id -- )

	C" Test -ShiftKey/Y" testmenu# append.items
			5 9 testmenu# set.item.modifiers ( item\modifer\menu.id -- )
	C" Test -OptKey/Y" testmenu# append.items
			6 10 testmenu# set.item.modifiers ( item\modifer\menu.id -- )
	C" Test -CtrlKey/Y" testmenu# append.items
			7 12 testmenu# set.item.modifiers ( item\modifer\menu.id -- )

	DrawMenuBar 
	testmenu# menu.selection: do.test.menu ;



AddTestMenu



\\

A CDEFGHIJKLMNO QRS UVWX Z  .\[]
 B             P   T    Y

