\ Simple example of use of Mac's SpeakString
\ SpeakString takes as argument a pointer to a counted string (up to 255 characters)

\ Last Revision: 13 Dec 2011  05:22:11  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************

only FORTH Definitions

anew --speech--

>m4th
decimal



extern: UInt32 OSERR  SpeakString ( UInt32 * cstr );
extern: UInt32 result SpeechBusy ( void );



: WaitSpeechAvail ( -- )	\ spinloop waiting for speech free or an ioevent, like a menubar
	BEGIN
		SpeechBusy
	WHILE
		do.io.events
	REPEAT ;


: SpeakString ( str -- osErr )
	WaitSpeechAvail		\ wait for any prior messages to complete
	SpeakString
;



\ Optional...
\ Courtesy Wil Baden
\ Redefines .(  ) to have your Mac speak these comments as files are included
\ ."  "  may still be used for displaying comments on the screen

: .( 
	[CHAR] ) word 
	speakstring drop ; 	immediate




.( Speak String is now ready for use by VFX Forth)




StopIncluding ************************************

\ select any or all the lines below and hit ENTER

.( 'Twas brillig, and the slithy toves)
.( Did gyre and gimble in the wabe;)
.( All mimsy were the borogoves,)
.( And the mome raths outgrabe.)


c" hello sailor!" SpeakString drop
c" I've been looking for you!" SpeakString drop
c" have a nice day!" SpeakString drop
c" and be sure to eat your Spinach!" SpeakString drop
WaitSpeechAvail

