\ Contextual Popup Menu for Editor
\ Last Revision: 09/15/03  03:54:58 PM  wjm - clip to bottom of screen
\ Last Revision: 25 Jan 2012  10:39:32  ward@megawolf.com

((
	OPTION-CLICK or RIGHT-CLICK on any text in Editor

))

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only forth definitions

anew --terminalPopup--
decimal

>m4th
also editorvocab
definitions


(( 

: (FindBestRemoteFuzzies)  ( cstr -- )
	RemoteContextWL
	IF
		ClearFuzzies
		0 -> BestFuzzyTag
		0 -> BestFuzzyValue
		0 -> #checked
		['] CheckFuzzyMatch RemoteContextWL >>apply
		2drop
	ELSE
		drop
	THEN
;
 ))
(( 
99 search$ (FindBestRemoteFuzzies) .s
 ))


: UseRemoteWL ( -- )		\ see MakeWLFromContext
	RemoteContextWL -> theWL
;


: LocateInRemote							\ llocate
	lf$ count	   WriteToRemote
	s"  locate "   WriteToRemote
	search$ count  WriteToRemote
	lf$ count	   WriteToRemote
;
\	['] LocateInRemote is LocateIt



: TerminalPopup ( -- flag )		\ EditorPopup
	selstart @ selend @ =
	IF
		TheIB -> PriorIB
		hide.range		\ RangeVis off
		selstart @ dup word.start  selstart !
					   word.end	   selend !
		show.range
	ELSE
		-1  -> PriorIB
	THEN
	selstart @ selend @ =
	IF	\ only works when click in a word, not in white space
		false
		beep
	ELSE
		AdjustEditorPopupPosition	\ 
\		MakeTerminalPopupMenu		\ *** MakeEditorPopupMenu	\ build it on the fly
		MakeEditorPopupMenu
	theWL >R
		RemoteContextWL -> theWL
		DoEditorPopupMenu \ DoTerminalPopupMenu			\ *** DoEditorPopupMenu
	R> to theWL
		true						\ exit editor CLICK.LOOP after doing the Popup
	THEN
;


only forth definitions
>m4th
also editorvocab


: (InstallTerminalPopup) ( -- )		\ see InstallEditorPopup
	['] LocateInRemote  	is LocateFromPopup
	['] TerminalPopup   	is Editor-Cntrl-Click
	['] FindInRemoteContext is ValidWord?
	['] UseRemoteWL			is MakeFuzzyWL
	['] RemoteContextWL		is AddHints?
;


\ ?BUILDING 0= [IF] (InstallTerminalPopup) [THEN]


 ' (InstallTerminalPopup) is InstallTerminalPopup

\ ['] TerminalPopup	TerminalWindow +MySE.CtrlClick !

\\

RemoteContextWL .s

DATA STACK
     top
       16951596 0102:A92C

ok \ 1 
handle.size .s

DATA STACK
     top
         156648 0002:63E8

ok \ 1 
thewl handle.size .s

DATA STACK
     top
         156648 0002:63E8
         156648 0002:63E8

ok \ 2 



ok \ 1 
