\ TSEPOS 1 1 1 \

\ ======
\ *> wid
\ ======

MODULE  VOCTOOLS

256 cells buffer: nThreadCount
variable nHeadSize
variable nWords

: (WidInfo)     \ thread# nfa -- flag
  1 nWords +!
  c@ HEADSIZE + nHeadSize +!
  cells nThreadCount + 1 swap +!
  TRUE
;

: WIDInfo       \ wid --
( *G Display loads of information about a given wordlist                )
  >r

  nThreadCount r@ >#threads @ cells erase
  0 nHeadSize !
  0 nWords !
  ['] (WidInfo) r@ WalkWordList

  cr
  cr ." Wordlist information:-"
  cr ."   There are " nWords @ . ." words in this list, "
     nHeadSize @ . ." bytes are used for headers"
  cr ."     Thread Distribution:-"
  r> >#threads @ 0 ?do
    cr ."     " i 3 .r 4 spaces ." = "
    nThreadCount i cells+ @ #1000 *	\ display x.y percent
    nWords @ ?dup if / then
    0 <# # [char] . hold #s #> type ." %"
  loop
;

EXPORT  WIDInfo
END-MODULE

: [forth]
  only forth definitions
; immediate


\ ======
( *> ###                                                                )
\ ======
