\ Mops prologue
\ Mike Hore  6 Apr 97.

\ If you're running under Mops, load this first, if you want to try
\  classM10.fth.  It's purpose is to make Mops sufficiently ANS-
\  compliant to be able to load and run classM10.fth.


\ Note, this file won't load under any other Forth.  If you're using
\  another system, it may already be ANS-compliant, or if not, there
\  might be a different prologue file you can use.


-echo
FALSE -> CASE_IN_NAMES?
false -> slctrs?				\ turn off Mops selector handling

true  -> ex-gen_immediates?		\ immediate words must use EX-GEN, not
								\  EXECUTE, since we can't EXECUTE does>
								\  words, and selectors are does> words
								\  and immediate!
								\  Note this disables optimization of a
								\  lot of things, but that doesn't matter
								\  for our limited purposes here.

\ ANSI redefinitions, from the ANSI file:

: :		0 -> state
		postpone :  ;

\ ***** this next line is Mops 2.8.x specific************
: :NONAME	:noname  nip 300  ;		\ correct for bug in 2.8.2 :noname


: immediate		postpone immediate  ;

: BASE		['] base  ;		\ BASE is a variable, not a value
: STATE		['] state  ;	\ Likewise STATE

: TO	postpone ->  ;		immediate

: FIND		dup count upper  find  ;

: CREATE	state IF  <builds  ELSE  create  THEN  ;


\ true -> case_in_names?		\ uncomment if you want case-sensitivity
