((

2008 By Rafael Gonzalez Fuentetaja
This file is placed in the public domain. NO WARRANTY.

))

\ *[

include ../sockets.fs

also sockets

-1 Value master				\ master listening socket fd
-1 Value slave 				\ returned socket fd by accept

7624 EndPoint: local any-ip
EndPoint: remote unknown-ip

256 Constant BufSize
BufSize Buffer: RxBuffer 

Create pollmaster /pollfd allot&erase
Create pollslave  /pollfd allot&erase 

: (main)
   TCP socket throw to master
   local master binds throw
   master listens throw

   master pollmaster pollfd.fd w!
   POLLIN pollmaster pollfd.events w!
   ."  now we block using poll" cr
   pollmaster 1 -1 polls throw
   pollmaster pollfd.revents w@ hex . decimal
   
   ." Ok, we are ready to accept" cr
   remote master accepts throw to slave
   cr ."  A client has connected " cr

   slave pollslave pollfd.fd w!
   POLLIN pollslave pollfd.events w!
   ." now we block using poll" cr
   pollslave 1 -1 polls throw
   pollslave pollfd.revents w@ hex . decimal
   
   RxBuffer 16 slave recvs throw
   RxBuffer swap Type cr

   slave pollslave pollfd.fd w!
   POLLIN pollslave pollfd.events w!
   ." now we block again using poll to detect remote close" cr
   pollslave 1 -1 polls throw
   pollslave pollfd.revents w@ hex . decimal
   RxBuffer 16 slave recvs throw .
   
;

: main
   ['] (main) catch
   dup errno-base < if .errno-excp  else throw then ;

main
\ *]

\ ======
\ *> ###
\ ======
