Forth Definitions
decimal


 \ 06/19/05 dbh  code lifted from Mops

:class ORDERED-COL  <super array
 var SIZE    \ # elements in list
 
:m SIZE: \ ( -- cursize )  Returns #elements currently in list
  get: size  ;m

:m CLEAR:
 clear: size    ;m

:m ADD:  \ ( val -- )  add value to end of list
 get: size  limit  >=  abort" Ordered-col full"
 get: size  to: [ self ]  1 +: size  ;m

:m LAST:  \ ( -- val )  Returns contents of end of list
 get: size dup 0= abort" Empty ordered-col"
 1-  at: self  ;m


\ Removes the element at index
:m REMOVE:  ( indx  -- )
 >r    \ indx to r
 get: size  r@ -  1-  ( cnt ) dup
     0<  abort" Can't remove: ordered-col"
 width: self  ( wid )
 r>  ^elem: self  ( addr )
 locals| addr wid cnt |
 1 -: size
 cnt  0= IF exit THEN
 addr wid +  addr  cnt wid *  move  ;m

\ Finds a value in a collection.
:m INDEXOF:  ( val  -- indx T  | -- F )
 width: self  ( wid )  idxbase ( addr )
 locals| addr wid val |
 false  get: size  0
 ?DO
  addr @ \ getelem: super
  val =  IF  drop  i  true  LEAVE  THEN
  wid addr + to addr
 LOOP  ;m


:m PRINT:
 get: size  0  ?do  i  at: self  cr .  loop  ;m

;class

 
