\ A TreeView Class


STRUCT{ TV_INSERTSTRUCT
      int hParent
      int hInsertAfter
      int mask
      int hItem
      int state
      int statemask
      int pszText
      int cchTextMax
      int iImage
      int iSelectedImage
      int cChildren
      int lparam
}

STRUCT{ TV_ITEM 
      int mask
      int hItem
      int state
      int statemask
      int pszText
      int cchTextMax
      int iImage
      int iSelectedImage
      int cChildren
      int lparam
}


Class CTreeCtrl


Private:    
      int hTreeView
Public:
      meth: InsertItem
      meth: Create            
      meth: Expand
      meth: GetItem
      meth: GetNextItem
      meth: GetNextSiblingItem
      meth: GetHwnd
      meth: Select
      meth: SetItem
      meth: SortChildren
      meth: DeleteAllItems
      meth: DeleteItem
      meth: GetCount
            

end-class


: CTreeCtrl::InsertItem             \ insertstruct -- hItem
      >r hTreeView TVM_INSERTITEM 0 r> SendMessage
;

: CTreeCtrl::Create                 \ style rect hwnd id -- 
      { style rect hwnd id }

      WS_EX_CLIENTEDGE
      z" SysTreeView32"
      NULL
      style 
      rect (CRect).topleft rect (CRect).width rect (CRect).height  hwnd id
      hwnd GWL_HINSTANCE GetWindowLong
      NULL
      CreateWindowEx -> hTreeView
;
      
: CTreeCtrl::Expand                 \ hitem code --
      { hItem Code }
      hTreeView TVM_EXPAND code hitem SendMessage drop
;

: CTreeCtrl::GetItem                \ *TVITEM -- 
      >r hTreeView TVM_GETITEM NULL r> sendmessage drop
;

: CTreeCtrl::GetNextItem            \ hitem code -- hitem
      { hItem Code }
      hTreeView TVM_GETNEXTITEM code hitem sendmessage
;

: CTreeCtrl::SortChildren           \ item -- 
      >r hTreeView TVM_SORTCHILDREN NULL r> sendmessage drop
;
            
: CTreeCtrl::GetNextSiblingItem     \ hitem -- item
      >r hTreeView TVM_GETNEXTITEM  TVGN_NEXT r> sendmessage
;

: CTreeCtrl::Select                 \ item code -- 
      { hItem Code }
      hTreeView TVM_SELECTITEM code hitem sendmessage drop
;
      
: CTreeCtrl::SetItem                \ *TVITEM -- 
      >r hTreeView TVM_SETITEM NULL r> sendmessage drop
;

: CTreeCtrl::GetHwnd                \ -- hwnd
      hTreeView
;

: CTreeCtrl::DeleteAllItems
     hTreeView TVM_DELETEITEM NULL TVI_ROOT SendMessage drop
;

: CTreeCtrl::DeleteItem             \ item --
     >r 
     hTreeView TVM_DELETEITEM NULL r> SendMessage drop
;

: CTreeCtrl::GetCount               \ -- n
     hTreeView TVM_GETCOUNT NULL NULL SendMessage
;
