\ **********************
\ And Block
\ **********************

Class CAndBlock : public CObject

public:

      CAnd    AndBox
      CBox    TextBox
      CLine   TopLine
      CLine   MiddleLine
      CLine   BottomLine

      CPoint  temp
      CPoint  LinkOut
      CPoint  LinkIn
      CRect   BoundingRect
      CString CommentText1
      CString CommentText2
      CString CommentText3
      CString LogicText
      50 Buffer: FileBuff
      
      int Parent
      Int Inputs
           
      Meth: Create
      Meth: Draw
      Meth: SetBoxText
      Meth: SetAndText 
      Meth: GetBoxText
      Meth: GetAndText
      Meth: AddInput
      Meth: Move 
      Meth: Print
      Meth: InFindRect  
      Meth: DrawBoundingBox
      Meth: SetTextOn
      Meth: SetTextOff 
      Meth: GetInputs
      Meth: GetInput 
      Meth: RemoveInput
      Meth: GetLinkOut
      Meth: GetLinkIn
      Meth: SetParent
      Meth: GetParent 
      Meth: Save
      Meth: GetTop
      Meth: GetLeft
      Meth: GetBottom
      Meth: GetRight

              
End-Class

: CAndBlock::SetBoxText       \ z$  n -- 
      case
      1 of CommentText1 (CString).SetLPCTSTR endof
      2 of CommentText2 (CString).SetLPCTSTR endof
      3 of CommentText3 (CString).SetLPCTSTR endof
      endcase     
;

: CAndBlock::SetAndText       \ z$ -- 
      LogicText (CString).SetLPCTSTR
;

: CAndBlock::GetBoxText       \ n -- z$
      case
      1 of CommentText1 (CString).GetLPCTSTR endof
      2 of CommentText2 (CString).GetLPCTSTR endof
      3 of CommentText3 (CString).GetLPCTSTR endof
      endcase 
;


: CAndBlock::GetAndText       \  -- z$
      LogicText (CString).GetLPCTSTR
;

: CAndBlock::SetTextOn               \  --
      TRUE to DrawText
;

: CAndBlock::SetTextOff               \  --
      FALSE to DrawText
;


: CAndBlock::Create       \ *CPoint -- 
      { *Point | id }
      NULL to Parent
      CList Dnew to Inputs
      20 Inputs (CList).init               \ init the inputs list for up to 20 inputs
      Inputs (Clist).Erase
      *Point LinkIn (CPoint).To
      \ create the top line
      *Point (CPoint).X *Point (CPoint).Y  *Point (CPoint).X *Point (CPoint).Y 10 + TopLine (CLine).CreateLine
    
      \ create the text box
      *Point (CPoint).GetXY Swap 50 - swap 10 + 100 40 BoundingRect (CRect).SetXYWH
      BoundingRect TextBox (CBox).CreateBox  
       

      \ create the middle line
      *Point (CPoint).X *Point (CPoint).Y 50 + *Point (CPoint).X *Point (CPoint).Y 60 + MiddleLine (CLine).CreateLine  
      
      \ create the AND box
      *Point (CPoint).GetXY Swap 30 - swap 60 + 60 60 BoundingRect (CRect).SetXYWH
      BoundingRect AndBox (CAnd).CreateBox    

      \ create the bottom line
      
      *Point (CPoint).X *Point (CPoint).Y 120 + *Point (CPoint).X *Point (CPoint).Y 130 + BottomLine (CLine).CreateLine
      *Point (CPoint).X *Point (CPoint).Y 130 + LinkOut (CPoint).SetXY
      
      TextBox (CBox).GetTopLeft drop BoundingRect (CRect).SetLeft
      TopLine (CLine).GetStart (CPoint).Y BoundingRect (CRect).SetTop
      TextBox (CBox).GetBottomRight drop  BoundingRect (CRect).SetRight
      BottomLine (CLIne).GetEnd (CPoint).Y BoundingRect (CRect).SetBottom
      
;
 

: CAndBlock::DrawBoundingBox  \ DC --
      { *DC }
      Red to LineColor
      LineColor Pen (CPen).SetColor
      LineWidth Pen (CPen).SetLineSize
      Selected 
      If
       PS_DOT
       Else
        PS_SOLID  
      Then 
      Pen (CPen).SetStyle
      Pen (CPen).MakePen
      *DC Pen (CPen).Select          \ select it      
      *DC BoundingRect (CRect).TopLeft temp ::MoveToEx drop
      *DC BoundingRect (CRect).BottomRight drop BoundingRect (CRect).TopLeft Nip ::LineTo drop
      *DC BoundingRect (CRect).BottomRight ::LineTo drop
      *DC BoundingRect (CRect).TopLeft drop BoundingRect (CRect).BottomRight Nip ::LineTo drop
      *DC BoundingRect (CRect).TopLeft ::LineTo drop
      *DC BLUE BoundingRect (CRect).CenterPoint  DrawBox  
      Pen (CPen).Delete 
;     



: CAndBlock::Draw      \  DC -- 
      { *DC | Text$ }
      *DC TopLine (CLine).Draw  
      *DC TextBox (CBox).Draw  
      *DC MiddleLine (CLine).Draw     
      *DC AndBox (CAnd).Draw
      *DC BottomLine (CLine).Draw
      DrawText
      If
       CommentText1 (CString).IsEmpty 0=
       If
         CommentText1 (CString).GetLPCTSTR to Text$
         *DC TextBox (CBox).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 19 - Text$ zcount TextOut Drop
       Then
       
       CommentText2 (CString).IsEmpty 0=
       If
         CommentText2 (CString).GetLPCTSTR to Text$
         *DC TextBox (CBox).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 7 - Text$ zcount TextOut Drop

       Then       
       
       CommentText3 (CString).IsEmpty 0=
       If
         CommentText3 (CString).GetLPCTSTR to Text$
         *DC TextBox (CBox).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 5 + Text$ zcount TextOut Drop
       Then       


       LogicText (CString).IsEmpty 0=
       If 
         LogicText (CString).GetLPCTSTR to Text$
         *DC AndBox (CAnd).GetCenter Swap Text$ zcount nip Chwidth * 2 / - swap 4 - Text$ zcount TextOut Drop
       Then
      Then
      Selected
      If
       *DC DrawBoundingBox
      Then
;

 
: CAndBlock::Move            \ *DC *CPoint --
      { *DC *Point }
      *DC *Point TopLine (CLine).move
      *DC *Point TextBox (CBox).moveBox
      *DC *Point middleLine (CLine).move
      *DC *Point AndBox (CAnd).moveAnd
      *DC *Point BottomLine (CLine).move
      *Point (CPoint).GetXY BoundingRect (CRect).OffsetRect
      *Point LinkIn  (CPoint).+=
      *Point LinkOut (CPoint).+=
;
 

: CAndBlock::Print
      Cr ." And Block"
      Cr ." Parent ID Is "  parent .
      Cr ." Input Ids Are "
      Inputs (CList).Items 1+ 1
      ?Do
       i Inputs (CList).FetchItem . 2 spaces
      Loop
;


: CAndBlock::InFindRect            \ *Rect -- f
      { *Rect }
      BoundingRect (CRect).TopLeft *Rect (CRect).XYPtInRect
      BoundingRect (CRect).BottomRight *Rect (CRect).XYPtInRect And
;  


: CAndBlock::AddInput          \ id --
      { id }
      
     \ first check if we have this id
     TRUE                                 \ flag assume for now we dont have this id
     Inputs (CList).Items 0
     ?Do
       i Inputs (CList).FetchItem id =    \ check
       If                                 \ ok we have it allready
        Drop FALSE Leave                  \ change flag and leave
       then
      loop
      if                                  \ not found
       id Inputs (CList).Add
      then
;



: CAndBlock::GetInputs        \ -- n
      Inputs (CList).Items
;

: CAndBlock::RemoveInput        \ *Item --
      { *Item | *List *Obj  }
      Inputs (CList).Items 0 >
      If
      CList Dnew to *List          \ make a new list
      20 *List (CList).init        \ initalize it 
      Inputs (CList).Items 0
      ?Do
        i Inputs (CList).FetchItem to *Obj
        *Item *Obj <>
        If                                         \ copy if no match
         *Obj *List (CList).add                    \ 
        Then
       Loop
       Inputs (CList).Free
       Inputs delete                  \ get rid
       *List to Inputs
       Then
;
         

: CAndBlock::GetInput         \ n -- n
      Inputs (CList).FetchItem
;

: CAndBlock::GetLinkIn  \ -- x y
      LinkIn (CPoint).GetXY
;

: CAndBlock::GetLinkOut
      LinkOut (CPoint).GetXY
;

: CAndBlock::SetParent  \ n --
      To Parent
;

: CAndBlock::GetParent
      Parent
;

: CAndBlock::Save
      ID_ANDBLOCK             FileBuff ! FileBuff CELL WriteFile ior If z" AndBlocK Failed to write type" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      LinkIn (CPoint).X       FileBuff ! FileBuff CELL WriteFile ior If z" AndBlocK Failed to write X" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      LinkIn (CPoint).Y       FileBuff ! FileBuff CELL WriteFile ior If z" AndBlocK Failed to write Y" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      FileBuff 20 Erase
      CommentText1 (CString).IsEmpty 0=
      If 
        CommentText1 (CString).GetLPCTSTR zcount FileBuff Swap ::move
      Then
      FileBuff 20 WriteFile ior If z" AndBlocK Failed to write Text1" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      
      FileBuff 20 Erase
      CommentText2 (CString).IsEmpty 0=
      If 
        CommentText2 (CString).GetLPCTSTR zcount FileBuff Swap ::move
      Then
      FileBuff 20 WriteFile ior If z" AndBlocK Failed to write Text2" ErrorBox.Msg ErrorBox.ShowMsgBox Then     
      
      FileBuff 20 Erase
      CommentText3 (CString).IsEmpty 0=
      If 
        CommentText3 (CString).GetLPCTSTR zcount FileBuff Swap ::move
      Then
      FileBuff 20 WriteFile ior If z" AndBlocK Failed to write Text3" ErrorBox.Msg ErrorBox.ShowMsgBox Then     
      
      
      
      
      FileBuff 20 Erase
      LogicText   (CString).IsEmpty 0=
      If
       LogicText   (CString).GetLPCTSTR zcount FileBuff Swap ::move
      Then 
      FileBuff 20 WriteFile ior If z" AndBlocK Failed to write Text2" ErrorBox.Msg ErrorBox.ShowMsgBox Then     
      Parent                  FileBuff ! FileBuff CELL WriteFile ior If z" AndBlocK Failed to write Parent" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      Inputs (CList).Items    FileBuff ! FileBuff CELL WriteFile ior If z" AndBlocK Failed to write Items" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      Inputs (CList).Items 0
      ?do
        i Inputs (CList).FetchItem FileBuff ! FileBuff CELL WriteFile ior If z" AndBloacK Failed to Write item" ErrorBox.Msg ErrorBox.ShowMsgBox Then
      Loop
      

;

: CAndBlock::GetTop        \ -- top
     BoundingRect (CRect).TopLeft Nip
;

: CAndBlock::GetLeft        \ -- left
     BoundingRect (CRect).TopLeft Drop
;


: CAndBlock::GetBottom    \ -- bottom
     BoundingRect (CRect).BottomRight nip
;

: CAndBlock::GetRight   \ -- right 
     BoundingRect (CRect).BottomRight drop
;