\ **********************
\ The base class CObject
\ **********************

Class CObject

Public:

      CPen   Pen              \ for drawing

      int GroupID             \ id for grouped objects
      int Copy                \ the copy flag
      int Selected            \ the selected flag
      int Linecolor           \ line color
      int LineWidth           \ line width
      int DrawText
      int ChWidth
      
      Meth: GetCopy
      Meth: SetCopy
      Meth: ClearCopy
      Meth: Group
      Meth: UnGroup
      Meth: GetGroupID
      Meth: DrawBox
      Meth: SetLineWidth
      Meth: SetLineColor
      Meth: SetSelected
      Meth: ClearSelected
      Meth: GetSelected
      Meth: SetChWidth
      
end-class

: CObject::SetChWidth   \ n --
      To ChWidth
;

: CObject::Group        \ id -- 
      to GroupID
;

: CObject::UnGroup
      FALSE to GroupID
;

: CObject::GetGroupID   \ -- id
      GroupID
;

: CObject::GetCopy      \ -- n
      Copy
;

: CObject::SetCopy      \ -- 
      TRUE to Copy
;
((
: CObject::GetDC
      DC
;
))
: CObject::ClearCopy
      FALSE to Copy
;

: CObject::SetLineColor          \ color --
      To LineColor            \ box color
;

: CObject::SetLineWidth          \ width --
      To LineWidth            \ box line width
;

: CObject::SetSelected     \ -- 
      TRUE To Selected
;

: CObject::ClearSelected
      FALSE To Selected
;

: CObject::GetSelected
      Selected
;


: CObject::DrawBox                  \ DC color x y --
      { *DC color x y }
      color  Pen (CPen).SetColor
      PS_SOLID Pen (CPen).SetStyle
      1 Pen (CPen).SetLineSize                              \ boxes are thin
      Pen (CPen).MakePen                        \ create the pen
      *DC Pen (CPen).Select
      *DC x y 4 - >r 4 - r> over 8 + over 8 + Rectangle drop
      Pen (CPen).Delete
;