#!/bin/bash
# set -x

VFXROOT=`pwd`
export VFXROOT

TEMPLATE="${VFXROOT}/template.ini"
# DESTFILE="${HOME}/VfxTest.ini"
DESTFILE="${HOME}/.VfxForth.ini"

awk -v path=${VFXROOT} >${DESTFILE} '
    BEGIN { FS="="}
    /CHANGEME$/ {
        hit=1;
        printf("%s=%s\n"),$1,path
    }
    {
        if (hit == 0) {
            print $ 0
        } else {
            hit = 0
        }
    }' < ${TEMPLATE}
