\ BuilderTest1.fth - Test GtkBuilder interface.

((
Copyright (c) 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20110909 SFP001 Converted from libglade version.
))

0 value MainBuilder	\ -- x ; main GtkBuilder object
0 value window1		\ -- x ; main window object
0 value MainAbout	\ -- x ; main About dialog object
0 value AppFinished?	\ -- x ; non-zero when app must quit

: GtkAppQuit	\ --
\ *G The GTK+ app should finish
  -1 to AppFinished?
\  gtk_main_quit				\ comment out if gtk_main not used
;

\ Some signal handlers
: on_save1_activate_fn
  2drop
;
2 0 CCB: on_save1_activate
' on_save1_activate_fn to-callback on_save1_activate

: on_delete1_activate_fn
\ cr ." delete event called" cr .s
  2drop drop  0
;
3 1 CCB: on_delete1_activate
' on_delete1_activate_fn to-callback on_delete1_activate

: on_cut1_activate_fn
  2drop
;
2 0 CCB: on_cut1_activate
' on_cut1_activate_fn to-callback on_cut1_activate

2 0 CCBproc: on_about1_activate	\ *widget *user -- ; -- entry
.s ." on_about1_activate_fn" cr
  MainAbout runDlg
." result = " .
;

2 0 CCBproc: on_aboutdialog1_close	\ *widget *user -- ; -- entry
.s ." on_aboutdialog1_close_fn" cr
  2drop
;

: on_open1_activate_fn
  2drop
;
2 0 CCB: on_open1_activate
' on_open1_activate_fn to-callback on_open1_activate

: on_paste1_activate_fn
  2drop
;
2 0 CCB: on_paste1_activate
' on_paste1_activate_fn to-callback on_paste1_activate

: on_new1_activate_fn
  2drop
;
2 0 CCB: on_new1_activate
' on_new1_activate_fn to-callback on_new1_activate

: on_save_as1_activate_fn
  2drop
;
2 0 CCB: on_save_as1_activate
' on_save_as1_activate_fn to-callback on_save_as1_activate

: on_copy1_activate_fn
  2drop
;
2 0 CCB: on_copy1_activate
' on_copy1_activate_fn to-callback on_copy1_activate

2 0 CCBproc: on_window1_destroy	\ *widget *user -- ; -- entry
  2drop  GtkAppQuit
;

: BuilderTest1	\ --
\ *G Test word to read a Glade XML file and run the GUI it describes.
  0 to AppFinished?  do_gtk_init  installGTKhooks
  z" gdemo2bld.ui" loadBuilderXML to MainBuilder
  MainBuilder z" window1" gtk_builder_get_object GTK_WIDGET to window1
  MainBuilder z" aboutdialog1" gtk_builder_get_object GTK_WIDGET to MainAbout
  window1 gtk_widget_show_all
\  gtk_main
;

: BuilderTest2	\ --
\ *G Test word to read a Glade XML file and run the GUI it describes.
  0 to AppFinished?  do_gtk_init installGTKhooks
  z" gdemo4bld.ui" loadBuilderXML to MainBuilder
  MainBuilder z" window1" gtk_builder_get_object GTK_WIDGET to window1
  MainBuilder z" aboutdialog1" gtk_builder_get_object GTK_WIDGET to MainAbout
  window1 gtk_widget_show_all
\  gtk_main
;


\ ======
\ *> ###
\ ======

decimal


