\ GladeTest.fth - example of an application built using libglade

((
Copyright (c) 2008, 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20110817 RML002 added "c" to bindings
20080325 VRW001 Initial (incomplete) release
))

0 value libgladeXML	\ -- x ; main GtkBuilder object
0 value window1		\ -- x ; main window object
0 value MainAbout	\ -- x ; main About dialog object

\ Some signal handlers
2 0 CCBproc: on_save1_activate	\ *widget *user -- ; entry
  2drop
;

3 1 CCBproc: on_delete1_activate
\ cr ." delete event called" cr .s
  2drop drop  0
;

2 0 CCBproc: on_cut1_activate
  2drop
;

2 0 CCBproc: on_about1_activate
.s ." on_about1_activate"
  2drop  MainAbout runDlg drop
;

2 0 CCBproc: on_aboutdialog1_close
  2drop
;

2 0 CCBproc: on_open1_activate
  2drop
;

2 0 CCBproc: on_paste1_activate
  2drop
;

2 0 CCBproc: on_new1_activate
  2drop
;

2 0 CCBproc: on_save_as1_activate
  2drop
;

2 0 CCBproc: on_copy1_activate
  2drop
;

\ An alias for the window destroy
2 0 CCBproc: on_window1_destroy
  destroy_fn
;

2 0 CCBproc: CloseApp_cb	\ *widget *user -- ; -- entry
  2drop  GtkAppQuit
;

: gladetest1	\ --
\ *G Test word to read a Glade XML file and run the GUI it describes.
  do_gtk_init
  z" test_project.glade" loadGladeXML to libgladeXML
  libGladeXML z" window1" glade_xml_get_widget GTK_WIDGET to window1
  libGladeXML z" aboutdialog1" glade_xml_get_widget GTK_WIDGET to MainAbout
  window1 gtk_widget_show_all
  gtk_main
;

: gladetest2	\ --
\ *G Test word to read a Glade XML file and run the GUI it describes.
  do_gtk_init  installGTKhooks
  z" gdemo2.glade"  loadGladeXML to libgladeXML
  libGladeXML z" window1" glade_xml_get_widget GTK_WIDGET to window1
  libGladeXML z" aboutdialog1" glade_xml_get_widget GTK_WIDGET to MainAbout
  window1 gtk_widget_show_all
;


\ ======
\ *> ###
\ ======

decimal


