\ pthreads.fth - OS X thread primitives

((
Copyright (c) 2007, 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
20110201 SFP001 OS X conversion.
))

only forth definitions
decimal

\ ===========
\ *! pthreads
\ *T Multitasking with the pthreads library
\ ===========

Library: libpthread.so.0

Extern: int pthread_create( unsigned long * thread, int * attr, void * start_routine, void * arg );
\ DON'T use the attributes parameter: it should be a pointer to a struct
Extern: int pthread_join(unsigned int th, void * * thread_return);
Extern: void pthread_exit( void *retval );
Extern: int pthread_detach( int th );
Extern: int sched_yield( void );

#256 buffer: test_message	\ -- addr
\ *G Text message sent to thread
  s" Test message!" test_message place

variable thread1	\ -- addr
\ *G Holds the thread handle.

1 1 callback: Thread1entry 	\ -- entrypoint
\ *G Callback function corresponding to the thread.

: Thread1Action		\ mesg -- status
\ *G Action of the *\fo{Thread1} task.
  count type 0
  begin
    1000 ms
    ." *"
  again
;
' Thread1Action to-callback Thread1Entry

: testit	\ --
  thread1 0 Thread1Entry test_message pthread_create .
;


\ ======
\ *> ###
\ ======

decimal

