\ 2009-08-22 01:09:40, removed restriction to nodes = n*16
\ 2009-12-09 18:40:41, assumes 16byte aligned data buffers
\ 2009-12-19 17:01:18, overlay support
INCLUDE fjack/overlay.frt

[DEFINED] save-sse2-overlay?
[IF]
CODE (calc-fir-val-sse2)
	HERE TO START-OVERLAYCODE
				rax	pop,
				rcx	pop,	\ data
				rdx	pop,	\ multipliers
	xmm0		->	xmm0	subpd,
BEGIN,	#16 b#		->	rax	sub,
0>=, WHILE,
	[rcx]		->	xmm1	movapd,
	[rcx $10 +]	->	xmm2	movapd,
	[rcx $20 +]	->	xmm3	movapd,
	[rcx $30 +]	->	xmm4	movapd,
	[rcx $40 +]	->	xmm5	movapd,
	[rcx $50 +]	->	xmm6	movapd,
	[rcx $60 +]	->	xmm7	movapd,
	[rcx $70 +]	->	xmm8	movapd,
	[rcx $80 +]	->	rcx	lea,
	[rdx]		->	xmm1	mulpd,
	[rdx $10 +]	->	xmm2	mulpd,
	[rdx $20 +]	->	xmm3	mulpd,
	[rdx $30 +]	->	xmm4	mulpd,
	[rdx $40 +]	->	xmm5	mulpd,
	[rdx $50 +]	->	xmm6	mulpd,
	[rdx $60 +]	->	xmm7	mulpd,
	[rdx $70 +]	->	xmm8	mulpd,
	[rdx $80 +]	->	rdx	lea,
	xmm2		->	xmm1	addpd,
	xmm4		->	xmm3	addpd,
	xmm6		->	xmm5	addpd,
	xmm8		->	xmm7	addpd,
	xmm3		->	xmm1	addpd,
	xmm7		->	xmm5	addpd,
	xmm1		->	xmm0	addpd,
	xmm5		->	xmm0	addpd,
REPEAT,	#16 b#		->	rax	add,
	3 b#		->	rax	bt,
cy, IF,	[rcx]		->	xmm1	movapd,
	[rcx $10 +]	->	xmm2	movapd,
	[rcx $20 +]	->	xmm3	movapd,
	[rcx $30 +]	->	xmm4	movapd,
	[rcx $40 +]	->	rcx	lea,
	[rdx]		->	xmm1	mulpd,
	[rdx $10 +]	->	xmm2	mulpd,
	[rdx $20 +]	->	xmm3	mulpd,
	[rdx $30 +]	->	xmm4	mulpd,
	[rdx $40 +]	->	rdx	lea,
	xmm1		->	xmm2	addpd,
	xmm3		->	xmm4	addpd,
	xmm2		->	xmm0	addpd,
	xmm4		->	xmm0	addpd,
THEN,	2 b#		->	rax	bt,
cy, IF,	[rcx]		->	xmm1	movapd,
	[rcx $10 +]	->	xmm2	movapd,
	[rcx $20 +]	->	rcx	lea,
	[rdx]		->	xmm1	mulpd,
	[rdx $10 +]	->	xmm2	mulpd,
	[rdx $20 +]	->	rdx	lea,
	xmm1		->	xmm0	addpd,
	xmm2		->	xmm0	addpd,
THEN,	1 b#		->	rax	bt,
cy, IF,	[rcx]		->	xmm1	movapd,
	[rdx]		->	xmm1	mulpd,
	[rcx $10 +]	->	rcx	lea,
	[rdx $10 +]	->	rdx	lea,
	xmm1		->	xmm0	addpd,
THEN,	0 b#		->	rax	bt,
cy, IF,	[rcx]		->	xmm1	movlpd,
	[rdx]		->	xmm1	mulsd,
	xmm1		->	xmm0	addsd,
THEN,	xmm0		->	xmm1	movapd,
	1 :: xmm1	->	xmm1	shufpd,
	xmm1		->	xmm0	addsd,
	[rbp #-16 +]	->	rbp	lea,
	xmm0		->	[rbp] movsd,
	[rbp]			qword fld,
				fpush,
	[rbp #16 +]	->	rbp	lea,
				rbx jmp,
	HERE TO END-OVERLAYCODE	END-CODE	S" firval" SAVE-OVERLAY

CODE (calc-adp-muls-sse2)
	HERE TO START-OVERLAYCODE
					fpop,
	[rbp -8 +]		qword	fstp,
	[rbp -8 +]	->	xmm0	movsd,
 	xmm1		->	xmm1	subpd,
	1 :: xmm0	->	xmm1	shufpd,
	xmm1		->	xmm0	addpd,
				rax	pop,
				rcx	pop,	\ data
				rdx	pop,	\ multipliers
BEGIN,	#16 b#		->	rax	sub,
0>=, WHILE,
	[rcx]		->	xmm1	movapd,
	[rcx $10 +]	->	xmm2	movapd,
	[rcx $20 +]	->	xmm3	movapd,
	[rcx $30 +]	->	xmm4	movapd,
	[rcx $40 +]	->	xmm5	movapd,
	[rcx $50 +]	->	xmm6	movapd,
	[rcx $60 +]	->	xmm7	movapd,
	[rcx $70 +]	->	xmm8	movapd,
	[rcx $80 +]	->	rcx	lea,
	xmm0		->	xmm1	mulpd,
	xmm0		->	xmm2	mulpd,
	xmm0		->	xmm3	mulpd,
	xmm0		->	xmm4	mulpd,
	xmm0		->	xmm5	mulpd,
	xmm0		->	xmm6	mulpd,
	xmm0		->	xmm7	mulpd,
	xmm0		->	xmm8	mulpd,
	[rdx]		->	xmm1	addpd,
	[rdx $10 +]	->	xmm2	addpd,
	[rdx $20 +]	->	xmm3	addpd,
	[rdx $30 +]	->	xmm4	addpd,
	[rdx $40 +]	->	xmm5	addpd,
	[rdx $50 +]	->	xmm6	addpd,
	[rdx $60 +]	->	xmm7	addpd,
	[rdx $70 +]	->	xmm8	addpd,
	xmm1	->	[rdx]		movapd,
	xmm2	->	[rdx $10 +]	movapd,
	xmm3	->	[rdx $20 +]	movapd,
	xmm4	->	[rdx $30 +]	movapd,
	xmm5	->	[rdx $40 +]	movapd,
	xmm6	->	[rdx $50 +]	movapd,
	xmm7	->	[rdx $60 +]	movapd,
	xmm8	->	[rdx $70 +]	movapd,
	[rdx $80 +]	->	rdx	lea,
REPEAT,	#16 b#		->	rax	add,
	3 b#		->	rax	bt,
cy, IF,	[rcx]		->	xmm1	movapd,
	[rcx $10 +]	->	xmm2	movapd,
	[rcx $20 +]	->	xmm3	movapd,
	[rcx $30 +]	->	xmm4	movapd,
	[rcx $40 +]	->	rcx	lea,
	xmm0		->	xmm1	mulpd,
	xmm0		->	xmm2	mulpd,
	xmm0		->	xmm3	mulpd,
	xmm0		->	xmm4	mulpd,
	[rdx]		->	xmm1	addpd,
	[rdx $10 +]	->	xmm2	addpd,
	[rdx $20 +]	->	xmm3	addpd,
	[rdx $30 +]	->	xmm4	addpd,
	xmm1	->	[rdx]		movapd,
	xmm2	->	[rdx $10 +]	movapd,
	xmm3	->	[rdx $20 +]	movapd,
	xmm4	->	[rdx $30 +]	movapd,
	[rdx $40 +]	->	rdx	lea,
THEN,	2 b#		->	rax	bt,
cy, IF,	[rcx]		->	xmm1	movapd,
	[rcx $10 +]	->	xmm2	movapd,
	[rcx $20 +]	->	rcx	lea,
	xmm0		->	xmm1	mulpd,
	xmm0		->	xmm2	mulpd,
	[rdx]		->	xmm1	addpd,
	[rdx $10 +]	->	xmm2	addpd,
	xmm1	->	[rdx]		movapd,
	xmm2	->	[rdx $10 +]	movapd,
	[rdx $20 +]	->	rdx	lea,
THEN,	2 b#		->	rax	bt,
cy, IF,	[rcx]		->	xmm1	movapd,
	xmm0		->	xmm1	mulpd,
	[rdx]		->	xmm1	addpd,
	xmm1	->	[rdx]		movapd,
THEN,
				rbx	jmp,
	HERE TO END-OVERLAYCODE	END-CODE	S" adpmul" SAVE-OVERLAY

CODE (SSE2-CODE?)	( -- flag )
	-1 ALLOT HERE TO START-OVERLAYCODE
 	1 b#	->	rax	mov,
 				cpuid,
 	$04000000 d# ->	rdx	and,
			rbx	pop,
 			rdx	push,
 			rbx	jmp,
	HERE TO END-OVERLAYCODE	END-CODE	S" testcpu" SAVE-OVERLAY

[ELSE]

CODE (calc-fir-val-sse2)
	S" firval" LOAD-OVERLAY END-CODE
CODE (calc-adp-muls-sse2)
	S" adpmul" LOAD-OVERLAY END-CODE
CODE (SSE2-CODE?)		( -- flag )
	-1 ALLOT S" testcpu" LOAD-OVERLAY END-CODE

[THEN]
