JACKAUDIO DEFINITIONS

\ loads binary code to the data space at here; returns old here and size
: (LOAD-OVERLAY)	( name len -- addr size )
	$100 ALLOCATE THROW 0 0 0 LOCALS| pos size fd buff |
	$FJACKSYSFILE COUNT buff PLACE
	1 CELLS 8 =	IF S" _64_" ELSE S" _32_" THEN buff PLACE+  buff PLACE+
	buff COUNT R/O OPEN-FILE SWAP TO fd 0=
	IF	fd FILE-SIZE ?FILE D>S TO size
		HERE DUP TO pos size ALLOT
		size fd READ-FILE 0<> SWAP size <> OR ABORT" Couldn't load the binary overlay"
		fd CLOSE-FILE DROP
	ELSE	buff FREE DROP TRUE ABORT" Could not open the binary overlay file"
	THEN
	buff FREE DROP
	pos size ;
: LOAD-OVERLAY		( name len -- )	\ this works fine for iforth
	(LOAD-OVERLAY) 2DROP ;

[DEFINED] save-sse2-overlay?
[IF]
	0 VALUE START-OVERLAYCODE
	0 VALUE END-OVERLAYCODE
	: SAVE-OVERLAY	( name size -- )
		$100 ALLOCATE THROW 0 LOCALS| fd buff |
		$FJACKSYSFILE COUNT buff PLACE
		64BIT?	IF S" _64_" ELSE S" _32_" THEN buff PLACE+ buff PLACE+
		buff COUNT R/W CREATE-FILE SWAP TO fd 0=
		IF	START-OVERLAYCODE END-OVERLAYCODE OVER - fd WRITE-FILE ABORT" Couldn't save the binary overlay"
			??CR ." Saved overlay"  buff COUNT TYPE
			fd CLOSE-FILE DROP
		ELSE	buff FREE DROP TRUE ABORT" Could not create the binary overlay file"
		THEN
		buff FREE DROP ;
[THEN]
