\ binder.fth for Windows

((
Copyright (c) 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
))

only forth definitions
decimal

\ ===========
\ *! filename
\ *T Chapter Title
\ ===========

cd S:\stephen\Products\VfxCommunity.dev\Sources\Kernel\386OSX\Notes

0 value FileBase	\ -- addr ; base address of file buffer
0 value hStub		\ -- hfile ; stub file handle
0 value /Stub		\ -- len ; stub length
$0000:1000 value /ForthImg	\ -- len ; size of Forth image
0 value LEbase		\ -- addr ; base address of LINKEDIT in memory
0 value LEresidue	\ -- len ; length remaining after

: getBuff	\ --
  10 Mb allocate abort" allocation failed" to FileBase
;

: readStub	\ --
  s" tststub" r/o open-file abort" open failed" to hStub
  hStub file-size abort" size failed" drop to /Stub
  FileBase /Stub hStub read-file abort" read failed" drop
  hStub close-file drop  -1 to hStub
;

: InImg		\ offset -- addr
  FileBase +
;

\ : SEARCH        \ c-addr1 u1 c-addr2 u2 -- c-addr3 u3 f

: findLE	\ --
  FileBase /Stub s" __LINKEDIT" search 0= abort" no LINKEDIT"
  8 + to LEresidue  8 - to LEbase	\ start is 8 bytes before string
;

$38 constant /seg

create ForthSeg	\ -- addr
\ Mach-O segment for the Forth image at 0x4000
  1 ,					\ LC_SEGMENT
  /seg ,					\ size
  z", __FORTH"    0 c, 0 c, 0 c, 0 c,  0 c, 0 c, 0 c, 0 c,
  $0000:4000 ,				\ vmaddr
  8 Mb ,				\ vmsize
  $0000:3000 ,				\ file offset
  /ForthImg ,				\ file size
  7 ,					\ maxprot
  7 ,					\ initprot
  0 ,					\ nsects
  0 ,					\ flags

: insertSeg	\ --
  findLE
  $1000:0000 LEbase 6 cells + !		\ rebase LINKEDIT vmaddr
  LEbase dup /seg + LEresidue move	\ move tail up
  ForthSeg LEbase /seg move		\ insert new segment
  1 4 cells InImg +!			\ number of commands
  /seg 5 cells inImg +!			\ size of commands
;

: writeStub	\ --
  s" tststubx" r/w create-file abort" create failed" to hStub
  FileBase $0000:4000 hStub write-file abort" write failed"
  hStub close-file drop  -1 to hStub
;



\ ======
\ *> ###
\ ======

decimal
