(* ====================================================================
Cocoa interface starter

copyright 2010 Roelf Toxopeus

Startup for turnkey.
MFonVFX version.
Last: 20 October 2020 at 14:26:00 CEST   -rt
==================================================================== *)

(( --------------------------------------------------------------------
/COCO-VFX -- initialize all pre cocoa stuff
HOT.COCO -- prepare and start ObjC Runtime and Cocoa
The starter word for turnkeyes.
NoTE: for turnkey remove the comment \ in front of /externals !
-------------------------------------------------------------------- ))

/forth
decimal

: /coco-vfx
   cr ." Not initiating externals !"
   \ /externals   \ for turnkey, do /externals !
   /rnd /machtime
   ['] machticks is Ticks
   CHECKING OFF ;               \  this is crucial for electives like FORK JOIN
   
: .COCO ( -- )
   cr ." Coco brewed: 20 October 2020 at 14:26:00 CEST"
   cr ." Cocoa served hot in Carbon"
;

also m4th
: .ABOUT ( -- )
   .cold
   mfversion count type cr
   .coco
;
previous

: hot.coco
   /coco-vfx
   cocoa.run            \ setup for Cocoa
   cr .about            \ tell me
   cr ( quit )            \ go Forth
;

\\ ( eof )
