(* ====================================================================
Simple Forth ObjC Runtime interface usage example

copyright 2010 Roelf Toxopeus

VFX version.
Last: 4 February 2019 at 13:51:26 CEST   -rt
==================================================================== *)

/forth
decimal

cocoaclass NSProcessInfo

cocoa: @processInfo ( -- NSProcessInfo:info )    \ NSProcessInfo method
cocoa: @processName ( -- NSString:name )         \ NSProcessInfo method
cocoa: @getCString: ( buffer -- zstring )   \ NSString method

: .PROCNAME ( -- )
   pad dup 40 erase                \ setup pad
   NSProcessInfo @processInfo      \ retrieve processinfo
   @processName                    \ get the name info
   @getCString: drop               \ use pad to convert name info into C string
   pad zcount type ;               \ yeah

cr .( simple example loaded ...)
cr .( type  .PROCNAME  to run it)

\\ ( eof )
