(* ===============================================================================
defines FORTHCALL:

copyright 2013 Roelf Toxopeus

VFX specific version.
Extends CB:
Last: 4 February 2019 at 12:51:22 CEST  -rt
=============================================================================== *)

(( -------------------------------------------------------------------------------
FORTHCALL: like VFX CallProc: is a parsing variant on CB: including :NONAME
for the xt. The stackpicture decides the #in and #out parameters, similar to FUNCTION:
Similar to CB: words created with FORTHCALL: leave the code address for the calback.
A kind of handy shortcut for those who use the :NONAME and CB: sequence a lot.

FORTHCALL: mycallback ( n1 n2 -- )  whatever needs to be done ;
   
For coco-vfx users,  synonym IBACTION: FORTHCALL:  makes nice/useful syntax sugar.

Note: coco-vfx versions prior to 4 February 2019 know this word as CALLBACK:
the coco-sf version. 
------------------------------------------------------------------------------- ))

: FORTHCALL: ( <text> -- )
   >in @ >r  parse-params  r> >in !  CallProc: ;

cr .( callback extension loaded)

\\ ( eof )
