(* ====================================================================
Cocoa interface starter

copyright 2010 Roelf Toxopeus

Startup for turnkey.
VFX version.
Last: 20 October 2020 at 14:26:00 CEST   -rt
==================================================================== *)

(( --------------------------------------------------------------------
Main goes coco, impostor goes Forth

GOES.FORTH -- do necessary initialisations and execute QUIT
HOT.COCO -- set pretender startup hook and launch coco-vfx.
The starter word for turnkeyes.
-------------------------------------------------------------------- ))

/forth
decimal

: .COCO ( -- )
      ." Coco brewed: 20 October 2020 at 14:26:00 CEST"
;

: .ABOUT ( -- )
   .cold
   .coco ;

[-short-branches
\ a slight variation on the original entrypoint code
: goes.forth      ( hmodule 0 commandline show -- flag )
   /cmdline
   /random
   /machticks
   nonap
     .about
     cr cr ." hello again " cr
     o_abort
   0
;
short-branches]

[-short-branches
: hot.coco ( -- )
   macpath c" cocoalib" $setmacro
   ['] goes.forth 'pretending !  coco.run 0 ;
short-branches]

\ ' hot.coco to-do EntryPoint

starter hot.coco

\\ ( eof )
