(* ====================================================================
Mouse cursor location

copyright 2010 Roelf Toxopeus

VFX64 version.
Fetching global mouse coordinates (as floatingpoints)
Last: 12 August 2020 at 07:37:13 CEST  -rt
==================================================================== *)

(( --------------------------------------------------------------------
@MOUSE -- return current mouse position on fp stack.
MM -- print mouse location until key hit.
-------------------------------------------------------------------- ))

/forth
decimal

cocoaclass NSEvent

cocoa: @mouseLocation ( -- ) ( F: -- x y )

: @MOUSE ( F: -- x y )   NSEvent @mouseLocation ;

: .MOUSE? ( y1 x1 y2 x2 f -- )
   if 2drop exit then
   2swap 2drop 2dup cr . . ;
   
: MM ( -- )
   0 dup begin
      @mouse f>s f>s 2over 2over d= .mouse?
   key? until 2drop ;

CR .( global mouse location fetcher loaded ...)
CR .( mm  -- to start demo, move mouse around. Any key stops)

\\ ( eof )