(* ====================================================================
Image slideshow

copyright 2006 Roelf Toxopeus

VFX64 version
Image/picture showing with CoreGraphics
Last: 18 August 2020 at 15:21:20 CEST  -rt
==================================================================== *)

(( --------------------------------------------------------------------
Slideshow precaution:
Change the hard coded image paths to a set of your images !!!
PHOTOWIN /GWINDOW    when included from LOAD-FILE menu.

PHOTOWIN has a certain amount of transparency. Optional set PHOTOWIN
to fullscreen.
Change DELAY to preferred value, default is 1 second.
-------------------------------------------------------------------- ))

\ --------------------------------------------------------------------

/forth
decimal

\ *** examples:

new.window PHOTOWIN
\ nowidgets photowin photowin w.style
s" PHOTO VIEW"       photowin w.title
80e-2                photowin w.transparency

: /PHOTOWIN ( -- )    photowin dup add.window /gwindow ;

/photowin
 
\ photowin full.screen

variable DELAY 1000 delay !

: SLIDESHOW ( -- )
   begin
      0" /transport/ijs/ijs01.tif" photowin drawpic
      delay @ ms
      0" /transport/ijs/ijs02.tif" photowin drawpic
      delay @ ms
      0" /transport/ijs/ijs03.tif" photowin drawpic
      delay @ ms
      0" /transport/ijs/ijs04.tif" photowin drawpic
      delay @ ms
      0" /transport/ijs/ijs05.tif" photowin drawpic
       delay @ ms
      0" /transport/ijs/ijs06.tif" photowin drawpic
      delay @ ms
      0" /transport/ijs/ijs07.tif" photowin drawpic
      delay @ ms
      ?pause
   until ;

task SLIDESHOW.RUNNER
: SLIDESHOW.RUNS ( -- )  slideshow.runner activate slideshow ;

cr .( slideshow demo loaded)
cr .( SLIDESHOW.RUNS   to start)
cr .( SLIDESHOW.RUNNER DONE stops )

\\ ( eof )