(* ===============================================================================
defines FORTHCALL:

copyright 2013 Roelf Toxopeus

VFX specific version.
Extends CB:
Last: 20 August 2020 at 17:38:23 CEST  -rt
=============================================================================== *)

(( -------------------------------------------------------------------------------
FORTHCALL: like VFX CallProc: is a parsing variant on CB: including :NONAME
for the xt. The stackpicture decides the #in and #out parameters, similar to FUNCTION:
Similar to CB: words created with FORTHCALL: leave the code address for the calback.
A kind of handy shortcut for those who use the :NONAME and CB: sequence a lot.

FORTHCALL: mycallback ( n1 n2 -- )  whatever needs to be done ;

The parameterlist is parsed as in FUNCTION:.
Integers only, but two return values alowed: ( 1 2 3 4 -- 5 6 )
See fp-in-callbacks.fth  for passing fp in callbacks.
 
For coco-vfx users,  synonym IBACTION: FORTHCALL:  makes nice/useful syntax sugar.

Note: coco-vfx versions prior to 4 February 2019 know this word as CALLBACK:
the coco-sf version.

------------------------------------------------------------------------------- ))

also extern.voc  \ parse-params now in VFX
: FORTHCALL: ( <text> -- )
   >in @ >r  parse-params  r> >in !  CallProc: ;
previous

cr .( callback extension loaded)

\\ ( eof )
