\ Forth Scientific Library test load

C" C:\Products\VfxForth.dev\Sources\Lib" setmacro optiondir
C" C:\Products\VfxForth.dev\Sources\Lib\x86"  setmacro floatdir

-short-branches

\ debugging tools for when something breaks
\ get %optiondir%\wview.fth
\ get %optiondir%\exexcept.fth
\ get %optiondir%\stackmon.fth

\ load the floating point pack and set it up for FSL use
\ get %floatdir%\hfp387	\ load floating point pack
include %floatdir%\ndp387	\ load floating point pack
  8 set-precision		\ so the tests line up
  char . dp-char !		\ select ANS number conversion
  char . fp-char !
  finit				\ initialise FP unit and stack
  floored			\ set NDP to round to floor

include Vfx4Util		\ FSL harness for VFX Forth 4.0+
\ include Vfx3Util		\ FSL harness for VFX Forth 3.7+

((
  get ExpInt
  get Horner	horner_test
))
\ get Dates		date-test
anew xx	get GaussJ		( TEST-MAT ( random )
				3EQS SOLVE-IT
