
 \ 06/19/05 dbh  code lifted from Mops

Have >= 0= [IF]
: >= ( n1 n2 -- f )
  swap 1+ < ;
[THEN]


:class ORDERED-COL  <super array
 var SIZE    \ # elements in list
 
:m SIZE: \ ( -- cursize )  Returns #elements currently in list
  get: size  ;m

:m CLEAR:
 clear: size  0 fill: self   ;m

:m ADD:  \ ( val -- )  add value to end of list
 get: size  limit  >=  abort" Ordered-col full"
 get: size  to: [ self ]  1 +: size  ;m

:m LAST:  \ ( -- val )  Returns contents of end of list
 get: size dup 0= abort" Empty ordered-col"
 1-  at: self  ;m

\ Removes the element at index
:m REMOVE:  ( indx  -- )
 >r    \ indx to r
 get: size  r@ -  1-  ( cnt ) dup
     0<  abort" Can't remove: ordered-col"
 width: self  ( wid )
 r>  ^elem: self  ( addr )
 1 -: size
 ( cnt wid addr )
 rot ( wid addr cnt )
 dup 0= IF exit THEN
 ( wid addr cnt )
 >r ( wid addr ) 2dup ( wid addr wid addr )
 + ( wid addr w+a )
 rot ( addr w+a wid )
 rot ( w+a wid addr )
 swap r> ( w+a addr wid cnt )
 * ( w+a ) ( a ) ( w*c) move ;m

\ Finds the index of a number in a collection.
:m INDEXOF:  ( n  -- indx T  | -- F )
 idxbase ( val addr )
 get: size  0
 ?DO
  2dup ( val addr val addr )
  @ =  IF i -1  LEAVE  THEN
  width: self ( val addr wid ) + ( val addr' )
 LOOP ( val addr indx -1 | val addr )
 -1 = IF nip nip true
    ELSE drop false
    THEN
 ;m

  :m first?: ( -- elem t | f )
  size: self 1 < IF false exit THEN
  clear: current
  0 at: self true ;m
  
 :m next?:  ( -- ^obj t | f )
  1 +: current get: | dup size: self <
  IF at: self true
  ELSE drop false
  THEN ;m


 :m deleteAll: ( n -- ) \ will delete all occurances of n
    >R
    BEGIN
      r@ indexof: self
    WHILE
      remove: self
    REPEAT
     R> drop ;m


\ print: is properly handled by array superclass

;class

 
