\ a Boyer-Moore search procedure

0 value case? \ true if case is to be significant in string comparisons

 : ->upper ( char -- char' )
   case? 0=
   IF dup [char] a [char] z 1+
       within IF 32 - THEN
   THEN ;

create lastTable 256 allot

: initLast lastTable 256 -1 fill ;  \ will actually fill with 255

0 value txtAddr
0 value txtCnt
0 value patAddr
0 value patCnt

: last ( char -- n ) \ char = offset into table
  lastTable + c@ dup 255 = IF drop -1 THEN ;

: toLast ( n char -- )
  lastTable + c! ;

: pat>Last
  patCnt 0 ?DO i dup patAddr + c@ ->upper toLast LOOP ;

0 value ti
0 value tj
0 value zz

: (search) ( txtAddr txtCnt patAddr patCnt -- offset t | f )
  to patCnt to patAddr to txtCnt to txtAddr
  initLast pat>Last
  patCnt dup to ti to tj
  BEGIN
     patAddr tj + c@ ->upper
     txtAddr ti + c@ ->upper dup to zz =
     IF tj IF   ti 1- to ti
                tj 1- to tj
           ELSE ti true exit
           THEN
     ELSE
        ti patCnt +
        ( txtAddr ti + c@ ->upper ) zz last 1+ tj MIN
        -   to ti
        patCnt 1- to tj
     THEN
   ti txtCnt >=
  UNTIL false ;

  

