0 [IF]
SEQUENCE is a generic superclass for classes which have multiple items which
frequently need to be looked at in sequence.  At present the main function of
Sequence is to implement the EACH: method, which makes it very simple to
deal with each element.  The usage is

 BEGIN  each: <obj>  WHILE  <do something to the element>  REPEAT

Sequence can be a superclass for any class which implements the
FIRST?: and NEXT?: methods.  The actual implementation details are quite
irrelevant, as long as these methods are supported.


[THEN]


\ selector next?:
\ selector first?:

:class SEQUENCE <super object <general
 bool each_started?

:m EACH:  \ ( -- (varies) T  |  -- F )
 get: each_started?
 IF \ Subsequent time in:
  next?: [ self ]
  IF  true  ELSE  clear: each_started?  false  THEN
 ELSE \ First time in:       
  first?: [ self ]  0= IF 0 exit THEN
  set: each_started?
  true  \ Yes, we've got the 1st element
 THEN
;m

:m UNEACH: \ Use to terminate an EACH: loop before the end.
 clear: each_started?
;m

  :m apply: ( xt -- )
     >r
    BEGIN
      each: self
    WHILE
      r@ ( elem xt ) execute
    REPEAT r> drop ;m

;class


