\ FILE MENU
\ Last Revision: 12 Feb 2012  08:20:49  ward@megawolf.com

\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


\ Bare minimum file menu.  Does Include..



only Forth definitions
>M4TH

decimal


2  value FileMenu#


CREATE Include.Types  ascii BLKS ,  ascii TEXT ,

\ ascii APPL CONSTANT "APPL


defer <<INCLUDED>>		\ defer so it can be used differently in Remote Editor
	' included  is <<INCLUDED>>

: (INCLUDE..)  ( -- )
\	0 2 include.types NRRecord
	0 0 0 NRRecord			\ all file types
	0  c" Include File"  c" INCLUDE"  0  c" Select a text file for INCLUDE"
	aNavEventProcPtr
	(NavGetFile) drop
	discard.activates
	NavReplyOK? 
	IF	
		true busy
		NDFSSPec FSSpec->ZString 
		?ShortenPath					\ 10.44
		zcount <<included>>				\ included 
	THEN
	FALSE busy
;

: INCLUDE..  ( -- )
	['] included is <<included>>
	(include..)
;


: DO.FILE.MENU
	0 hilitemenu
	case 1 of INCLUDE..	endof
\	   ( 2 is a separator )
\		 3 of BYE		endof
	endcase ;


: FILE.MENU     
	FileMenu#  get.next.id c" File" FileMenu# new.menu
	C" Include/I" 
	FileMenu# append.items
	DrawMenuBar

	FileMenu# menu.selection: DO.FILE.MENU ;



StopIncluding ************************************

