(see /MF Docs/Change History for recent changes)

FONT

*******
 SETUP
*******

MFonVFX.app is a stand-alone application (not run in Terminal) built on
top of standard VFX Forth for the Mac, along with many (not all) of the
extensions of Carbon MacForth. 


Be sure to setup your VFX folder as per VFX installation document -
ReadMe.OSX.txt

 If you have already installed VFX successfully, skip to step 7

Summary of Installing VFX for Mac folks who are not entirely comfortable with
using Terminal.  Remember Unix and therefore terminal, is CASE SENSITIVE
for most things, so watch CasE as well as spelling.


1. You do not need to use Terminal to extract VFX's .tgz file - just
double click in Finder and it will get expanded to a single folder named
'VfxOsxPro'  - move it WHEREVER you want to work - I would not recommend
using in Apple folders,like Applications and Utilities that may have special 
and restricted permissions.  I have a separate disk partition for my own
style of organization and it works fine there.  Just in your User folder
is quite satisfactory as well.

2. You want 4 special files copied to system folders that need permission
to modify.  This is easiest to do with a little script run in Terminal.

3. Launch /Utilities/Terminal and set its working directory to 'VfxOsxPro'
The Mac shortcut is to do this in a new Terminal window:
	a. type "cd "  (the trailing space is important) but do not terminate
		the line yet
	b. In Finder, locate the VfxOsxPro folder and DRAG its icon onto the
		Terminal window.  This should emplace the full path into
		the command line.
		In my case, the line looks like:
			iMac:~ ward$ cd /Volumes/Development/MPE/VfxOsxPro
	c. NOW, hit return in Terminal to execute the whole line
	d. If you did it correctly, the Terminal prompt should reflect
		the new current directory, e.g. in my case
			iMac:VfxOsxPro ward$ 

		If the name of your VFX folder is not there, repeat steps a-c !

4. In Terminal, type or past the next line (cAsE sensitive)
	chmod +x InstallMe.Osx32.sh
	hit <returnkey>

5. In Terminal, type or paste (don't skip the leading period)
	./InstallMe.Osx32.sh
	hit <returnkey>
Since this copies files to protected OS X folders, you will be prompted for
your password

6. Typing   vfxosx  	<returnkey>
should now start the basic VFX Forth.  You can confirm that the current
directory is correctly set by typing 
  CD  <returnkey>

If you plan on using VFX in this mode, go to the VFX Manual and continue
setup as described in Chapter 2.2

A quick summary of those:
setup the basic macros that will get saved in VfxForth.ini

a, In vfxosx running in Terminal, execute:
   ( DO NOT PASTE -- USE THE PATH TO YOUR VFX FOLDER)
c" /Users/<yourname>/VfxOsxPro"  	setmacro basepath
c" /Users/<yourname>/VfxOsxPro"  	setmacro devpath
c" /Users/<yourname>/VfxOsxPro"  	setmacro vfxpath


b. Setup the Help system: (this is to use TextWrangler & Skim)
(also see step 9 below)
- SKIM is available at http://skim-app.sourceforge.net/
- done by InstallMe.Osx32.sh now  (drag a copy of /VFXRoot/Bin/skimpage.scpt to /usr/bin/)
- TextWrangler is Free at http://www.barebones.com/

In vfxosx running in Terminal, execute:
s" %BASEPATH%/doc/VfxOsx"			HelpBase$ place
s\" skimpage.scpt \q%h%.pdf\q %p%"  HelpCmd$  place
#16 HelpPage0 !

BYE
(exiting vfxosx any other way, like closing the Terminal window will NOT
save your changes)


If you are just going to be using MacForth on VFX, you are finished
with Terminal. 



 Setting up MacForth on VFX

7.  Unzip MFonVFX10.xx.zip to get the folder "MacForthOnVFX"

Move the "MacForthOnVFX" into your working VFX source folder, at the same
directory level as "Bin' 'Doc' 'Tools' 'Sources' etc .  This will ensure that
we can Locate MF and VFX Source files and the VFX manual. 2


8. Open the 'MacForthOnVFX' folder in your VFX folder and 
Double-click 'MFonVFX.app' to launch it


9. Things should basically run fine, EXCEPT you are running on a different
disk than MacForth was built on, so it will not be able to locate its
source or help files until we do a little more setting up.

10, In MFonVFX.app open the file "/MF Docs/Setup init file.fth"

With that file as the front window, CMD-K or File Menu:Save&Include
to include that file.  It should cause MFonVFX to quit to the Finder.
(the BYE is necessary to ensure the VFXForth.ini file is updated)


11.  Re-launch VFX and pull down the Project Menu.  If all of the files
listed under the PROJECT Menu are black, then everything is in its correct
location and VFXForth.ini is set correctly. 


12.  To access the VFX Manual and Help functions, you need a PDF Viewer that
can be scripted to open to a specified page #.  Preview will not be able to
jump to the specified page.

The Open Source PDF viewer. SKIM, is recommended for viewing the VFX Manual

- the latest version of Skim will be found at:  http://skim-app.sourceforge.net/
- you also need to drag the helper file
/VFXRoot/Bin/skimpage.scpt
to
/usr/bin/  (use finder's 'Go to Folder' menu command to locate it easily)
-- you will be prompted for your Mac password


The MacForth locate function should not require you to set up the VFX
Editor preferences, but it isn't a bad idea to do so, since rebuilding
MFonVFX will require running VFX in Terminal and errors there will invoke
the standard VFX error locate functions. 

I like TextWrangler for that purpose (see above).
"/MF Docs/Setup init file.fth" should have set up the correct macro to use
with TextWrangler.








*************************
  MACFORTH PREFERENCES
*************************

DEFAULT.EXTENSIONS is still used for most of configuring the MacForth layer,
but it is now stashed inside the MFonVFX bundle.  It can be quickly opened
from the Options Menu using 'Edit Launch Script' or as the Preferences item
under the Application Menu. 


You should open it NOW and change USERNAME$ near the top.
