\ Last Revision: 15 Jan 2012  12:57:38  ward@megawolf.com

(( 

Manually execute

INCLUDE..

and select this file


Using the Menu Include functions can cause problems since we will be forgetting the
code that define SE.INCLUDE and SAVE&INCLUDE
so that clean completion of those routines will be iffy

 ))



only Forth definitions
>M4TH

decimal



--NOTOOLS--		\ Marker that forgets everything after Floating Point


include" MF Examples/Scientific Calculator Demo.fth"


(( 
: ExitToShellOnQuit ( -- )
\ only time we might end up in QUIT is after an ABORT or ERROR
\ be better to have an alert-based error reporter for production code
	beep 1000 ms beep 1000 ms beep
	1000 ms
	bye ;  	quitter linklasttoken
 ))


: TKyQuit ( -- )
	\ we dont want to drop into the interpreter with QUIT
	init-quit  r0 @ rp!  exc0 @ excp !
	event.loop
;  	quitter linklasttoken


: ErrorAlert (  c-addr -- )
	>R
	c" ERROR !!! "
	cr$ cr$
	R> Big:-(OK/QUIT# dfltissuealert 
	1 <>
	IF
		exittoshell
	THEN
;
	' ErrorAlert  is DoAbortMessage
	' ErrorAlert  is DoErrorMessage

((
: ByeWhenClosed ( -- )
\ Quit application if main window is closed
	CalculatorNibWindow ?wvisible not 
	?turnkey and
	IF bye THEN
;  nulleventer linklasttoken
))

: My.AEOpenApp ( -- )
\ Our Open Application standard AppleEvent handler
\ we get this event only if no documents were selected for AEOpenFile
\ i.e, our turnkey was double-clicked
	401 GetPicture ?dup
	IF
		About.Anything			\ show our splash screen
	ELSE
\		ExitToShellOnQuit		\ exit beeping
	THEN
;


: My.AEReOpenApp
	DoCalculator
;



: StartCalculator  ( -- | Turnkey startup word )
	io.events off
	events off						\ hold off events

	\ install (null) Apple Event handlers
	['] My.AEOpenApp	is AEOpenApp
	['] 3drop			is AEOpenFile
	['] 3drop 			is AEPrintFile
	['] bye				is AEQuitApp
	['] My.AEReOpenApp	is AEReOpenApp

	apple.menu  
\	file.menu
\	1 false FileMenu# Item.Enable 	\ disable INCLUDE...
	edit.menu  -edit.menu
	init.cursor
	ShowCursor


	['] GetCalculatorNib catch
	IF	\ if we are missing our Nib file, we are sunk
		beep
		c" Missing Nib Resource"  "" "" "" OK# issuealert drop
		bye
	THEN

	DoCalculator
\	InfoCtrl InstallNibControl			\ only in turnkey

	events on							\ enable events
	event.loop
;




turnkey" Calculator Turnkey.app" StartCalculator

\ turnkey StartCalculator

