\ OLD MacForth Simple QD Colors
\ Should not be used for new develeopment
\ LOCATE RGBForeColor to see better color words


\	This file allows existing applications take advantage of Quickdraw's
\	existing color operators. Use of this common subset is directly
\	comtatible with all future Macintosh products.

\   If you simply want to load this file, for example with the demos,
\   you can place this folder in the Demos folder as well.  All demos
\ 	which need color will attempt to load this file if necessary.
\
\ Last Revision: 16 Feb 2012  08:26:28  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************

Only Forth definitions
decimal
>M4TH



\ These are the the Original QuickDraw color facilities

Extern:  void   ForeColor	( UInt32 n );  	\ color for pen, Paint method	
Extern:  void   BackColor	( UInt32 n ); 	\ color for Background eg. erase, fill

\ Inside Macintosh Names for colors
\
\ Note: the format for "Old-Model Quickdraw" color values is as follows:
\
\	Bit0:  	Monochrome drawing bit. ( Black on white) If this bit is set, the 
\			color will be rendered as black on a monochrome display.  Note 
\			that only White below has this bit cleared. 
\
\	Bit1:	Inverted Monochrome (White on black)  determines how this color
\			is rendered if SRCXOR mode is used.
\
\	Bits2-4: Additive primary colors.  This color mix is used for displaying
\			 the color with an "additive" color display such as a CRT display
\			 ( all colors off is black; all colors on is white) 
\ 			 0-7 indexed colors are:
\			 0     1      2       3   4    5     6    7
\			 Black Yellow Magenta Red Cyan Green Blue White   
\
\   Bits5-8 Subtractive primary colors.  This color mix is used for displaying
\			the color with an "Subtractive" color display such as an 
\			Imagewriter II equipted with a color ribbon.
\			 ( all colors off is White; Black color on is Black) 
\			 Bit5:  Black,  Bit6: Yellow,  Bit7: Magenta,   Bit8:Cyan)

 2 base !

\ Key:  CMYB:GBR:I:B  Cyan Magenta Yellow Black Green Blue Red Invert Black
   		0001:000:0:1 constant BlackColor
   		0010:001:0:1 constant YellowColor
   		0100:010:0:1 constant MagentaColor
   		0110:011:0:1 constant RedColor			
   		1000:100:0:1 constant CyanColor
   		1010:101:0:1 constant GreenColor		
   		1100:110:0:1 constant BlueColor
   		0000:111:1:0 constant WhiteColor

Decimal

\ Note: that the above color representations are skewed toward what may be
\		displayed on a least common denominator Imagewriter II, and will
\		most likely not do justice to a high performance CRT display
\		( These colors will look a bit sunbleached ).


	
create colors 			\ Arbitrary Pen Ordering for use in pen selection
	 ( 0) 	WhiteColor		w,		\ all colors > 0 render black on
	 ( 1)	YellowColor 	w,		\ displays w/o color
	 ( 2)	GreenColor		w,
	 ( 3)	CyanColor		w,
	 ( 4)	BlueColor		w,
	 ( 5)	MagentaColor	w,  
	 ( 6)	RedColor   		w,			
	 ( 7)	BlackColor		w,			


: pencolor  ( n -- )  \  paint selected color
					  \ Note that this works in conjunction with the current
					  \ Pen pattern.  To obtain a solid color, use:
					  \ Black PenPat
	  7 and 2 * colors + w@ forecolor  ;


: fillcolor  ( n -- )  \  paint selected color
					  \ Note that this works in conjunction with the current
					  \ Background pattern.  To obtain a solid color, use:
					  \ White BackPat
	  7 and 2 * colors + w@ backcolor  ;


