\ OPTIONS MENU
\ Last Revision: 12 Feb 2012  08:18:24  ward@megawolf.com


\ ***************************************************************************
\ (c) Copyright 2012  by MegaWolf, Inc.
\ All Rights Reserved. 
\ Permission is hereby granted to VFX Forth for Mac customers 
\   to use this source code in their own applications.
\ Sale, Distribution or other use of this source code is prohibited. 
\ ***************************************************************************


only Forth definitions
>M4TH

decimal



4 value OptionsMenu#

defer EditLaunchScript			' noop is EditLaunchScript
defer EditBuildScript			' noop is EditBuildScript
defer ViewLogFile				' noop is ViewLogFile
defer MoreOptions ( item -- )		\ hook for later expansion
	' drop is MoreOptions


: (>MF.WINDOW) ( -- )
	dflt.con mfCONSOLE !
	sys.window Show.Window 
	sys.window Select.Window
	sys.window window
	sys.window infile !
	sys.window active.window ! ;


: >MF.WINDOW ( -- )
	0 HiliteMenu
	console.stream
	dflt.con mfconsole !
	skip.events off
	events on
	(>mf.window)
    outfile on
	SilentAbort	;		\ 10.46 abort ;

' >MF.WINDOW  is AlertAbort


: OPTION.ITEM  ( item\addr -- | sets up check for item )
	@ boolean  optionsmenu# item.check  ;



: UPDATE.OPTIONS  ( -- )
	OptionsMenu# GetMenuHandle
	IF
		3 Noisy @  optionsmenu# item.check
	THEN ;  BeforeMenuSelect linklasttoken

 
: CleanWorkspace ( -- )
	optionkey? 0=
	IF
		c" Tries to Forget all definitions you have added since the last snapshot."
		cr$  cr$
		c" Be sure that all your files are saved!"
		Continue# issuealert 2 =
	THEN
	IF
		s"  anew xxxx" evaluate		\ XXXX is added in Default.Extensions
	THEN ;



: DO.OPTIONS.MENU ( item -- )
	0 hilitemenu
	CASE
		1 OF >mf.window 			 			ENDOF
		3 OF Noisy dup toggle32  option.item	ENDOF
		5 OF sys.window force.window 			ENDOF
		7 OF EditLaunchScript 		 			ENDOF
		8 OF EditBuildScript 		 			ENDOF
		9 OF ViewLogFile 		 				ENDOF
		11 OF CleanWorkspace 		 			ENDOF
		MoreOptions
		beep
	ENDCASE ;



: OPTIONS.MENU  ( -- )
	OptionsMenu#  get.next.id  C" Options" 	OptionsMenu# new.menu
	C" Abort/.;-(;Noisy"					OptionsMenu# append.items
	C" -(;MacForth Window" 					OptionsMenu# append.items
	C" -(;Edit Launch Script" 				OptionsMenu# append.items
	C" Edit Build Script" 					OptionsMenu# append.items
	C" View Log File" 						OptionsMenu# append.items
	C" -(;Clean Workspace" 					OptionsMenu# append.items

	DrawMenuBar

	update.options
	['] update.options update.status !		\  probably obsolete

	OptionsMenu# MENU.SELECTION: do.options.menu ;



\ for now, just open Default.Extensions as Preferences action

' EditLaunchScript -> PreferenceMenuAction





StopIncluding ************************************
