\ The generic class.
\ by Rafael Gonzalez. Public Domain. NO WARRANTY.



object class
   
   \ private field members
   
   cell%  inst-var m-name		\ hardware item name
   cell%  inst-var m-parent		\ parent item
   cell%  inst-var m-next		\ next element pointer
   cell%  inst-var m-price		\ item price
   
 protected 
   
   \ protected methods
   
   m: ( obj this -- obj )
      m-parent ! ;m
   method parent!
   
   m: ( this -- obj )
      m-next @ ;m
   method next@
   
   m: ( obj this -- )
      m-next !  ;m
   method next!

 public
   
   selector price    ( this -- n1 )  \ calculates price of this hw-item
   selector selftest ( this -- )     \ prints a selftest message
   
   \ public methods

   m: ( price ca u this -- )
      m-name $! m-price !  0 dup m-parent ! m-next ! ;m
   overrides construct

   \ cannot be overriden
   m: ( this -- obj )
      m-parent @ ;m
   method parent

   \ cannot be overriden
   m: ( this -- obj )
      m-name $@ type space ;m
   overrides print

   m: ( this -- price )
      m-price @ ;m
   overrides price

    m: ( this --  )
      this print ." Item Ok." cr ;m
   overrides selftest

end-class hw-item
