((
$Date: 2008-02-11 00:27:54 +0100 (lun, 11 feb 2008) $
$Revision: 450 $
$Author: astrorafael $
$HeadURL$

2008 By Rafael Gonzalez Fuentetaja
This file is placed in the public domain. NO WARRANTY.
))

\ =======================================================================

\ *> examples

\ *S Very simple TCP server example.
\ *P Shows non-blocking use of sockets.
\ ** Child sockets are blocking even if the master is not.
\ ** *\fo{recv-mt} returns when something is available, even if we asked
\ ** to read *\fo{BufSize} bytes.
\ =========================================================================

\ *[

\ =========================================================================

include ../src/sockets.fs

-1 Value master
-1 Value slave 

7624 EndPoint: local any-ip
EndPoint: remote unknown-ip

256 Constant BufSize

BufSize Buffer: RxBuffer 

: (server)
   TCP socket throw to master
   local master binds throw
   master listens throw

   remote master accepts-mt throw to slave
   slave -blocking throw
   cr ." A client has connected" cr
   RxBuffer BufSize slave recvs-mt throw
   RxBuffer swap type cr
;

: server
   ['] (server) catch
   dup errno-base < if .errno-excp else throw then ;

server
\ *]


\ ======
\ *> ###
\ ======
